/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.commerce.pim.common;

import java.io.IOException;

import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.jcr.Session;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletResponse;

import aQute.bnd.annotation.ConsumerType;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.resource.ResourceResolver;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.cq.commerce.pim.api.CatalogBlueprintImporter;
import com.day.cq.commons.jcr.JcrUtil;
import com.day.cq.wcm.api.Page;
import com.day.cq.wcm.api.PageManager;
import com.day.cq.wcm.api.WCMException;

/**
 * An abstract base class used for writing product importers.
 */
@Component(componentAbstract = true, metatype = true)
@Service
@ConsumerType
public abstract class AbstractBlueprintImporter extends AbstractImporter implements CatalogBlueprintImporter {
    private static final Logger log = LoggerFactory.getLogger(AbstractBlueprintImporter.class);

    protected String basePath = "/content/catalogs";

    protected long startTime;

    protected int catalogCount;                         // number of catalogs created
    protected int sectionCount;                         // number of catalog sections created

    public void importBlueprints(SlingHttpServletRequest request, SlingHttpServletResponse response) throws ServletException, IOException {
	}

    /**
     * Validate any input required to run the importer.  Implementation to be supplied by concrete classes.
     * @param request
     * @param response
     * @return
     * @throws IOException
     */
    protected abstract boolean validateInput(SlingHttpServletRequest request, SlingHttpServletResponse response) throws IOException {
		return false;
	}

    /**
     * Creates the top-level catalog blueprint page.
     * @param pageManager
     * @param storePath
     * @param catalogTitle
     * @param session
     * @return
     * @throws RepositoryException
     * @throws WCMException
     */
    protected Page createCatalog(PageManager pageManager, String storePath, String catalogTitle, Session session)
            throws RepositoryException, WCMException {
				return null;
			}

    /**
     * Creates a section blueprint within the catalog.
     * @param pageManager
     * @param parentPath
     * @param hierarchy
     * @param sectionTitle
     * @param session
     * @return
     * @throws RepositoryException
     * @throws WCMException
     */
    protected Page createSection(PageManager pageManager, String parentPath, String[] hierarchy, String sectionTitle, Session session)
            throws RepositoryException, WCMException {
				return null;
			}

    /**
     * Sets a property on a catalog or section blueprint.  The path can be nested (ie: templates/product).
     * @param node
     * @param propertyPath
     * @param value
     * @throws RepositoryException
     */
    protected void setProperty(Node node, String propertyPath, String value) throws RepositoryException {
	}

    protected String makeTickerMessage() {
		return null;
	}


}
