/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.contentinsight;

import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ValueMap;

/**
 * A service for accessing Content Insight provider settings for
 * resources, e.g. pages.
 */
public interface ProviderSettingsManager {

    /**
     * Returns a map of providers each containing a map of settings
     * for the given resource.
     * @param res The resource for which to get provider settings.
     */
    public ValueMap getProviderSettings(Resource res) {
		return null;
	}
    
    /**
     * Checks whether active providers are available for the given resource.
     * @param res The resource for which to check providers.
     */
    public boolean hasActiveProviders(Resource res) {
		return false;
	}
}
