/*
 * ADOBE CONFIDENTIAL
 *
 * Copyright 2015 Adobe Systems Incorporated
 * All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and may be covered by U.S. and Foreign Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 */

package com.adobe.cq.dam.cfm;

import aQute.bnd.annotation.ProviderType;

import java.util.Iterator;

/**
 * Implementations of this class represent a single meta data definition.
 */
@ProviderType
public interface MetaDataProperty {

    /**
     * Gets the (technical) name of the meta data property.
     *
     * @return The name
     */
    String getName() {
		return null;
	}

    /**
     * Gets the (human-readable) title of the meta data property.
     *
     * @return The title
     */
    String getTitle() {
		return null;
	}

    /**
     * Gets the type of the meta data property.
     *
     * @return The type of meta data
     */
    String getType() {
		return null;
	}

    /**
     * Gets a config property of the meta data property.
     *
     * <p>Available properties are dependant on the type of the meta data.</p>
     *
     * @param name The name of the config property
     * @return The value of the config property
     */
    Object getConfig(String name) {
		return null;
	}

    /**
     * Gets an iterator on the names of the config properties that are available.
     *
     * @return Iterator on config proeprties names
     */
    Iterator<String> getConfigNames() {
		return null;
	}

}
