//******************************************************************************
// ADOBE CONFIDENTIAL
// ___________________
//
//  Copyright 2017 Adobe Systems Incorporated
//  All Rights Reserved.
//
// NOTICE:  All information contained herein is, and remains
// the property of Adobe Systems Incorporated and its suppliers,
// if any.  The intellectual and technical concepts contained
// herein are proprietary to Adobe Systems Incorporated and its
// suppliers and may be covered by U.S. and Foreign Patents,
// patents in process, and are protected by trade secret or copyright law.
// Dissemination of this information or reproduction of this material
// is strictly forbidden unless prior written permission is obtained
// from Adobe Systems Incorporated.
//******************************************************************************

package com.adobe.cq.dam.dm.internalapi.image_server;

import java.io.IOException;
import java.io.InputStream;

/**
 * Provides helper API for getting data for those "renditions"
 * that are served via is/content/ context of image server and
 * are not represented by JCR resource nodes.
 */
public interface IsContentRequester {

    /**
     * Get response size and mime type
     * (cheaper then getting an full rendition data)
     * @param path URL path as it should appear in image server request
     *             but excluding is/content prefix
     * @return rendition properties instance.
     * @throws IOException if underlying HTTP request fails
     * @throws IllegalArgumentException if specified path does not start
     * with valid rootId
     */
    ResponseProps getResponseProps(String path) throws IOException {
		return null;
	}

    /**
     * Get response data stream.
     * @param path URL path as it should appear in image server request
     *             but excluding is/content prefix
     * @return rendition data instance.
     * @throws IOException if underlying HTTP request fails
     * @throws IllegalArgumentException if specified path does not start
     * with valid rootId
     */
    InputStream getInputStream(String path) throws IOException {
		return null;
	}

}
