/*************************************************************************
 * ADOBE CONFIDENTIAL
 * __________________
 * <p>
 * Copyright 2017 Adobe Systems Incorporated
 * All Rights Reserved.
 * <p>
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.editor.model;

import java.util.List;
import javax.annotation.Nullable;

import aQute.bnd.annotation.ProviderType;

/**
 * Interface for a single style group item, used by the {@link StyleSelector} model.
 */
@ProviderType
public interface StyleGroupItem {

    /**
     * Retrieves the readable name of the style group item.
     *
     * @return the style group item label if defined, {@code null} otherwise
     */
    @Nullable
    String getLabel() {
		return null;
	}

    /**
     * Retrieves the list of style items for a group.
     *
     * @return the list of style items if defined, empty list otherwise
     */
    List<StyleItem> getStyles() {
		return null;
	}

    /**
     * Checks if a style group item allows multiple selection or not.
     *
     * @return {@code true} if multiple style selection is allowed for the style group, {@code false} otherwise
     */
    boolean isMultiple() {
		return false;
	}
}
