/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2017 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 **************************************************************************/
package com.adobe.cq.editor.model;

import javax.annotation.Nullable;

import aQute.bnd.annotation.ProviderType;

/**
 * Interface for a single style item, used by the {@link StyleSelector} model.
 */
@ProviderType
public interface StyleItem {

    /**
     * Retrieves the ID of the style item.
     *
     * @return the style item ID if defined, {@code null} otherwise
     */
    @Nullable
    String getId() {
		return null;
	}

    /**
     * Retrieves the readable name of the style item.
     *
     * @return the style item label if defined, {@code null} otherwise
     */
    @Nullable
    String getLabel() {
		return null;
	}

    /**
     * Checks if a style item is selected or not.
     *
     * @return {@code true} if the style item is selected, {@code false} otherwise
     */
    boolean isSelected() {
		return false;
	}
}
