/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 **************************************************************************/
package com.adobe.cq.editor.model.inplaceediting.config;

import java.util.Iterator;

import javax.annotation.PostConstruct;
import javax.inject.Inject;

import org.apache.commons.lang.StringUtils;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.request.RequestParameter;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ValueMap;
import org.apache.sling.models.annotations.Model;
import org.apache.sling.models.annotations.injectorspecific.RequestAttribute;
import org.apache.sling.models.annotations.injectorspecific.Self;
import org.apache.sling.models.annotations.injectorspecific.ValueMapValue;

/**
 * Wrapper suitable for providing its children with the resource that actually contains a given IPE configuration
 *
 * The look-up of IPE configuration search for the requested resource in the following order:
 *
 * - design/policy
 * - component local
 * - component relocated
 */
@Model(adaptables = SlingHttpServletRequest.class)
public class ConfigWrapper {

    private static final String PN_POLICY_CONTENT_RESOURCE_TYPE = "policyContentResourceType";

    private static final String COMPONENT_RELATIVE_IN_PLACE_EDITING = "cq:editConfig/cq:inplaceEditing";
    private static final String COMPONENT_RELATIVE_IPE_CONFIG = COMPONENT_RELATIVE_IN_PLACE_EDITING + "/config";
    private static final String GRANITE_CONTENT_PATH_ATTRIBUTE = "granite.ui.form.contentpath";
    private static final String POLICY_RESOURCE_TYPE = "wcm/core/components/policy/policy";
    private static final String CONFIG_PATH = "configPath";

    @Self
    private SlingHttpServletRequest slingRequest;

    @Inject
    private ResourceResolver resourceResolver;

    /** Contextual resource */
    @Inject
    private Resource resource;

    private Resource designResource;

    @ValueMapValue(optional = true,
            name = CONFIG_PATH)
    private String configPath;

    @RequestAttribute(name = GRANITE_CONTENT_PATH_ATTRIBUTE)
    private String initialContentPath;

    @PostConstruct
    protected void initModel() {
	}

    /**
     * Search for an IPE configuration set on the design or on the component
     *
     * If the design has no configuration and the component has one, sets the location of the configuration to the "granite.ui.form.contentpath" slingRequest attribute
     */
    private void setContentPath() {
	}

    private void setInheritedContentPath(Resource componentResource) {
	}

    /**
     * Returns the resource concerned by the given slingRequest
     *
     * @param request
     * @return
     */
    private Resource getComponentResource(SlingHttpServletRequest request) {
		return null;
	}

    public Iterator<Resource> getChildren() {
		return null;
	}

    /**
     * Sets the "granite.ui.form.contentpath" slingRequest attribute back to its initial value
     */
    public void resetAttribute() {
	}
}
