/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ************************************************************************/
package com.adobe.cq.screens.device;

import javax.annotation.Nonnull;

import aQute.bnd.annotation.ProviderType;

/**
 * {@code DeviceStatus}...
 */
@ProviderType
public interface DeviceStatus {

    Ping getLastPing() {
		return null;
	}

    @Nonnull
    Firmware getFirmware() {
		return null;
	}

    @ProviderType
    interface Ping {

        long getTime() {
			return 0L;
		}
    }

    @ProviderType
    interface Firmware {

        String getVersion() {
			return null;
		}

        long getLastUpdated() {
			return 0L;
		}

    }
}