/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.community.api;

public enum CommunityUserGroup {

    ADMINISTRATOR() {
        @Override
        public String getName() {
            return CommunityConstants.TENANT_ADMINISTRATORS_GROUP;
        }
    },

    MODERATOR() {
        @Override
        public String getName() {
            return CommunityConstants.TENANT_MODERATORS_GROUP;
        }
    },

    GROUP_ADMIN() {
        @Override
        public String getName() {
            return CommunityConstants.TENANT_GROUPADMIN_GROUP;
        }
    },

    MEMBER() {
        @Override
        public String getName() {
            return CommunityConstants.TENANT_USERS_GROUP;
        }
    },

    SITE_CONTENT_MANAGER() {
        @Override
        public String getName() {
            return CommunityConstants.TENANT_SITE_CONTENT_MANAGER_GROUP;
        }
    },

    SITE_MEMBER() {
        @Override
        public String getName() {
            return CommunityConstants.TENANT_SITEMEMBER_GROUP;
        }
    },

    COMMUNITY_MANAGER() {
        @Override
        public String getName() {
            return CommunityConstants.TENANT_COMMUNITY_MANAGER_GROUP;
        }
    },

    PRIVILEGED_MEMBER() {
        @Override
        public String getName() {
            return CommunityConstants.TENANT_PRIVILEGED_MEMBER_GROUP;
        }
    },

    SITE_ENABLEMENT_MANAGER() {
        @Override
        public String getName() {
            return CommunityConstants.TENANT_SITE_ENABLEMENT_MANAGERS_GROUP;
        }
    };

    public abstract String getName();
}
