/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.enablement.learningpath.endpoints.api;

import java.util.Map;

import javax.jcr.Session;
import javax.servlet.http.HttpServletResponse;

import org.apache.felix.scr.annotations.Activate;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Properties;
import org.apache.felix.scr.annotations.Property;
import org.apache.felix.scr.annotations.Reference;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.commons.osgi.PropertiesUtil;
import org.osgi.service.component.ComponentContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.cq.social.enablement.learningpath.model.api.EnablementLearningPathModel;
import com.adobe.cq.social.scf.Operation;
import com.adobe.cq.social.scf.OperationException;
import com.adobe.cq.social.scf.OperationExtension;
import com.adobe.cq.social.scf.SocialComponent;
import com.adobe.cq.social.scf.core.operations.AbstractOperationService;

/**
 * Provides abstract implementation of the EnablementLearningPathModel operation..
 * @param <T> is a {@link OperationExtension} that will be used as hooks by the extending class.
 * @param <U> is a {@link Operation} that is being provided by the extending class.
 */
@SuppressWarnings("rawtypes")
@Component(metatype = false, componentAbstract = true)
@Properties({@Property(name = AbstractEnablementLearningPathModelOperationService.PROPERTY_FIELD_WHITELIST,
        value = {}, description = "List of allowed whitelisted custom properties", cardinality = 100)})
public abstract class AbstractEnablementLearningPathModelOperationService<T extends OperationExtension, U extends Operation>
    extends AbstractOperationService<T, U, EnablementLearningPathModel> implements
    EnablementLearningPathModelOperations {

    /**
     * Logger.
     */
    private final Logger LOGGER = LoggerFactory.getLogger(getClass());

    @Reference
    private EnablementLearningPathModelServiceCreate enablementLearningPathModelOperationServiceCreate;

    @Reference
    private EnablementLearningPathModelServiceUpdate enablementLearningPathModelOperationServiceUpdate;

    @Reference
    private EnablementLearningPathModelServicePublish enablementLearningPathModelOperationServicePublish;

    /**
     * Custom white list of input parameters
     */
    protected String[] fieldWhitelist;
    protected static final String PROPERTY_FIELD_WHITELIST = "fieldWhitelist";

    /**
     * Activate this component. Open the session and register event listeners.
     * @param context The component context
     */
    @Activate
    protected void activate(final ComponentContext context) {
	}

    // /
    // / Create operation
    // /
    @Override
    public SocialComponent create(final SlingHttpServletRequest request) throws OperationException {
		return null;
	}

    // /
    // / Update operation
    // /
    @Override
    public SocialComponent update(final SlingHttpServletRequest request) throws OperationException {
		return null;
	}

    // /
    // / Publish operation
    // /
    @Override
    public SocialComponent publish(final SlingHttpServletRequest request) throws OperationException {
		return null;
	}

    protected String getResourceType() {
		return null;
	}

    protected abstract U getCreateOperation() {
		return null;
	}

    protected abstract U getPublishOperation() {
		return null;
	}

    protected abstract U getUpdateOperation() {
		return null;
	}

    protected abstract U getReportOperation() {
		return null;
	}
}
