/*******************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *******************************************************************************/
package com.adobe.cq.social.enablement.reporting.model.api;

import com.adobe.cq.social.scf.SocialComponent;

public interface EnablementResourceReportModel extends SocialComponent {

    public static final String RESOURCE_TYPE = "social/enablement/components/hbs/model/resource/report";

    /**
     * @return resource title
     */
    public String getTitle() {
		return null;
	}

    /**
     * Gets the due status.
     * @return
     */
    public String getDueStatus() {
		return null;
	}

    /**
     * Determine if this enrollment is for a learning path.
     * @return true iff the enrollment is for a learning path
     */
    public boolean isLearningPath() {
		return false;
	}

    /**
     * Gets the number of resources in the learning path.
     * @return number of resources
     */
    public int getLearningPathResourceCount() {
		return 0;
	}

    /**
     * Determine if this is enrollment is for a scorm resource.
     * @return true iff the enrollment is for a scorm resource
     */
    public boolean isScormResource() {
		return false;
	}

    /**
     * @return true iff analytics is enabled for the site this resource is associated with
     */
    public Boolean getAnalyticsEnabled() {
		return null;
	}

    /**
     * Gets the asset type of the resource this report is associated with (e.g. video).
     * @return
     */
    public String getPrimaryAssetType() {
		return null;
	}
}
