/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.enablement.resource.model.api;

import org.apache.sling.api.resource.PersistenceException;

import com.adobe.cq.social.enablement.exceptions.EnablementException;
import com.adobe.cq.social.scf.SocialComponent;

public interface EnablementSocialModel extends SocialComponent {

    public static final String RESOURCE_TYPE = "social/enablement/components/hbs/model/resource/social";

    public static final String SOCIAL = "se_social";
    public static final String COMMENTS = "se_discussion";
    public static final String RATINGS = "se_ratings";

    /**
     * @return model representing enablement social comments resource
     */
    public EnablementSocialCommentsModel getComments() {
		return null;
	}

    /**
     * @return model representing enablement social ratings resource
     */
    public EnablementSocialRatingsModel getRatings() {
		return null;
	}

    /**
     * Creates the enablement social ratings resource endpoint.
     * @param displayName
     * @return
     * @throws PersistenceException
     * @throws EnablementException
     */
    public EnablementSocialRatingsModel updateSocialRatingsResource(final String displayName)
        throws PersistenceException, EnablementException {
		return null;
	}

    /**
     * Creates the enablement social comments resource endpoint.
     * @param displayName
     * @return
     * @throws PersistenceException
     * @throws EnablementException
     */
    public EnablementSocialCommentsModel updateSocialCommentsResource(final String displayName)
        throws PersistenceException, EnablementException {
		return null;
	}
}
