/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.enablement.resource.reporting.api;

import com.adobe.cq.social.reporting.analytics.AnalyticsReport;

public interface EnablementResourceAnalyticsReport extends AnalyticsReport {

    /** Resource type of component with analytics sub-node. */
    String ANALYTICS_RESOURCE_TYPE = "social/commons/components/analyticsbase";

    /** CQ variable for resource path (evar). */
    String EVAR_RESOURCE_PATH = "eventdata.path";

    /** CQ variable for resource type (evar). */
    String EVAR_RESOURCE_TYPE = "eventdata.resourcetype";

    /** CQ variable for resource view (event). */
    String EVENT_RESOURCE_VIEW = "eventdata.events.SCFView";

    /** CQ variable for resource play (event). */
    String EVENT_RESOURCE_PLAY = "eventdata.events.playresource";

    /** CQ variable for resource rate (event). */
    String EVENT_RESOURCE_RATE = "eventdata.events.SCFRate";

    /** CQ variable for resource comment (event). */
    String EVENT_RESOURCE_COMMENT = "eventdata.events.SCFCreate";

}
