/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.enablement.resource.reporting.api;

import com.adobe.cq.social.reporting.dv.api.DVLineChart;

/**
 * Enrollment video resource dropoff report interface.
 */
public interface EnablementResourceVideoDropoffReport extends DVLineChart, EnablementResourceAnalyticsReport {

    /** Resource type of component. */
    String RESOURCE_TYPE = "social/enablement/components/hbs/reports/resource/videodropoffreport";

    /**
     * Returns true iff a Marketing cloud org id has been configured for the site that the enablement resource belongs
     * to.
     * @return true if video heartbeat analytics enabled for a site
     */
    boolean isVideoHeartbeatAnalyticsEnabled() {
		return false;
	}
}
