/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.group.client.api;

import java.util.List;

import com.adobe.cq.social.scf.community.CommunityUser;
import com.adobe.cq.social.site.api.BaseSiteConfiguration;

import aQute.bnd.annotation.ProviderType;

@ProviderType
public interface CommunityGroupConfiguration extends BaseSiteConfiguration {
    /**
     * Get the members for this group
     * @return the users
     */
    List<CommunityUser> getMembers() {
		return null;
	}

    /**
     * Gets the member Ids.
     * @return the members
     */
    List<String> getMemberIds() {
		return null;
	}

    /**
     * Get the moderators for this group
     * @return the moderators
     */
    List<CommunityUser> getModerators() {
		return null;
	}

    /**
     * Gets the moderators.
     * @return the moderators
     */
    List<String> getModeratorIds() {
		return null;
	}

    /**
     * Get the group root path of this site
     * @return paths
     */
    String[] getGroupPaths() {
		return null;
	}

    /**
     * Gets the manager Ids.
     * @return the managers
     */
    List<String> getManagerIds() {
		return null;
	}

    /**
     * Get the Managers for this group
     * @return the managers
     */
    List<CommunityUser> getManagers() {
		return null;
	}
}
