/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.group.client.api;

import java.util.Calendar;

import com.adobe.cq.social.scf.SocialComponent;

/**
 * The Interface CommunitySiteFolder.
 */
public interface CommunityGroupFolder extends SocialComponent {

    /** The resource type. */
    String RESOURCE_TYPE = "social/group/components/hbs/groupcollection/groupfolder";

    /** The property isCommunityGroup. */
    String CQ_IS_COMMUNITY_GROUP = "cq:isCommunityGroup";

    /** The base configuration for site base */
    String FOLDER_CONFIG_NODE_NAME = "folderConfiguration";

    /**
     * Get the site page path.
     * @return root path of the site
     */
    String getSitePagePath() {
		return null;
	}

    /**
     * Get the Community Site Name.
     * @return the name of the site
     */
    String getName() {
		return null;
	}

    /**
     * User id of the site creator.
     * @return User id of the site creator
     */
    String getCreator() {
		return null;
	}

    /**
     * Get the site description.
     * @return description of the site
     */
    String getDescription() {
		return null;
	}

    /**
     * Gets the created.
     * @return the created
     */
    Calendar getCreated() {
		return null;
	}

    /**
     * Gets the modified.
     * @return the modified
     */
    Calendar getModified() {
		return null;
	}

    /**
     * Checks if is new.
     * @return true, if is new
     */
    boolean isNew() {
		return false;
	}

    /**
     * This is community site base page.
     * @return true,
     */
    boolean getIsCommunityGroupFolder() {
		return false;
	}

}
