/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.qna.client.api;

import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ValueMap;

import com.adobe.cq.social.forum.client.api.BaseForumConfiguration;

public class QnaConfiguration extends BaseForumConfiguration {
    private final ValueMap qnaForumProperties;
    private boolean moveSelectedAnswerToTop;

    public QnaConfiguration(Resource forumResource) {
        super(forumResource);
        qnaForumProperties = getForumProperties();
        moveSelectedAnswerToTop =
            (qnaForumProperties != null) ? qnaForumProperties.get(QnaPost.QNA_MOVE_SELECTED_ANSWER_TO_TOP, false)
                : false;
    }

    /**
     * Gets the move selected answer to top.
     * @return the move selected answer to top
     */
    public boolean getMoveSelectedAnswerToTop() {
		return false;
	}
}
