/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.srp.internal;

import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.apache.sling.api.wrappers.ModifiableValueMapDecorator;

/**
 * <code>SocialModifiableValueMap</code> decorates another {@link Map} to provide a basic implementation for the
 * additional methods of a {@link ModifiableValueMapDecorator}.
 * @since 0.0.1
 */
class SocialModifiableValueMap extends ModifiableValueMapDecorator {
    private static final Set<String> KEY_BLACK_LIST;

    static {
        KEY_BLACK_LIST = new HashSet<String>();
        KEY_BLACK_LIST.add(AbstractSchemaMapper.getSocoKey());
        KEY_BLACK_LIST.add(AbstractSchemaMapper.getSocoParentIdKey());
    }

    private final MapResourceImpl resource;

    /**
     * Creates a new wrapper around a given map.
     * @param resource wrapped object
     */
    public SocialModifiableValueMap(final MapResourceImpl resource) {
        super(resource.adaptTo(Map.class));
        this.resource = resource;
    }

    @Override
    public Object put(final String key, final Object value) {
		return null;
	}

    @Override
    public Object remove(final Object key) {
		return null;
	}

    @Override
    public void clear() {
	}

    @Override
    public void putAll(final Map<? extends String, ? extends Object> m) {
	}

    @Override
    public <T> T get(final String name, final Class<T> type) {
		return null;
	}

}
