/*******************************************************************************
 * ADOBE CONFIDENTIAL
 * __________________
 *
 * Copyright 2016 Adobe Systems Incorporated
 * All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ******************************************************************************/

package com.adobe.cq.socialmedia;

import aQute.bnd.annotation.ProviderType;

/**
 * Defines a Social Media application
 */
@ProviderType
public interface SocialApplication {

    /**
     * Set up the SM application
     *
     * @param appId        Application ID
     * @param appToken     Application Secret
     * @param hostname     Web application hostname (ex.: https://localhost:4502)
     * @param socialAction Action executed after OAuth
     * @return OAuth URL
     */
    String setUpApp(String appId, String appToken, String hostname, SocialAction socialAction) throws SocialException {
		return null;
	}

    /**
     * Returns the application name
     *
     * @return
     */
    String getName() {
		return null;
	}

    /**
     * Returns the link to the SM for an individual post
     *
     * @param params
     * @return Link to the SM network
     * @throws SocialException
     */
    String getPostLink(SocialPostLinkParams params) throws SocialException {
		return null;
	}


}
