/*******************************************************************************
 * ADOBE CONFIDENTIAL
 * __________________
 *
 * Copyright 2016 Adobe Systems Incorporated
 * All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ******************************************************************************/

package com.adobe.cq.socialmedia;

/**
 * Defines mandatory parameters for deleting a post
 */
public class SocialPublisherDeleteParams extends SocialParams{

    /**
     * Creates delete post parameters
     * @param postId The ID of the post to be deleted
     * @param spaceId Space where the post exists (ex.:Page ID/ Board name)
     */
    public SocialPublisherDeleteParams(String postId, String spaceId) {
        params.put("postId", postId);
        params.put("spaceId", spaceId);
    }

}
