/*******************************************************************************
 * ADOBE CONFIDENTIAL
 * __________________
 *
 * Copyright 2016 Adobe Systems Incorporated
 * All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ******************************************************************************/

package com.adobe.cq.socialmedia;

import java.io.InputStream;

/**
 * Defines mandatory parameters for publishing content to a SM network
 */
public class SocialPublisherPublishParams extends SocialParams {

    /**
     * Creates publish parameters
     * @param pictureUrl URL pointing to existing picture on the WEB
     * @param description Picture description
     * @param spaceId Space where the picture will be posted (ex.:Page ID/ Board name)
     */
    public SocialPublisherPublishParams(String pictureUrl, String description, String spaceId) {
        params.put("pictureUrl", pictureUrl);
        params.put("description", description);
        params.put("spaceId", spaceId);
    }

    /**
     * Creates publish parameters
     * @param picture Picture as InputStream
     * @param description Picture description
     * @param spaceId Space where the picture will be posted (ex.:Page ID/ Board name)
     */
    public SocialPublisherPublishParams(InputStream picture, String description, String spaceId) {
        params.put("picture", picture);
        params.put("description", description);
        params.put("spaceId", spaceId);
    }

}
