/*******************************************************************************
 * ADOBE CONFIDENTIAL
 * __________________
 *
 * Copyright 2016 Adobe Systems Incorporated
 * All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ******************************************************************************/

package com.adobe.cq.xf.ui;

import aQute.bnd.annotation.ProviderType;

import java.util.Set;

/**
 * A meta object for the Experience Fragment console.
 * This object holds metadata which is used to filter out the actions available to the user
 */
@ProviderType
public interface ExperienceFragmentPageMeta {

    /**
     * Returns the title of this page
     * @return a String representing the title
     */
    String getTitle() {
		return null;
	}

    /**
     * Checks whether this console shows a folder or now
     * @return <code>true</code> if the console shows a folder, <code>false</code> otherwise
     */
    boolean isFolder() {
		return false;
	}

    /**
     * Returns the actions that are available in this console. This is used to filter out the actions that we want to hide from the user
     * @return a {@link Set} of String values. The values must correspond to the "granite:rel" property of the actions that we want to be available
     */
    Set<String> getActionRels() {
		return null;
	}

}
