/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/


package com.adobe.dam.print.ids;

import java.util.List;

import aQute.bnd.annotation.ProviderType;
import org.apache.sling.api.resource.PersistenceException;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.event.jobs.Job;
import com.day.cq.dam.api.Asset;

import javax.jcr.RepositoryException;

@ProviderType
public interface PrintService {
    
    /**
     * Creates a sling job for exporting pdf & indd rendition of asset if the print rendition exists 
     *
     * @param master asset for which print mapping is already defined as a rendition
     * @param formats list of export formats
     */
    Job createExportJob(Asset master, List<PrintFormat> formats) throws PersistenceException {
		return null;
	}

    /**
     * Creates a sling job for exporting jpg renditions of pages of template if the print rendition exists
     *
     * @param master asset for which print mapping is not yet defined
     */
    Job createExportPagesJob(Asset master) throws PersistenceException {
		return null;
	}

    /**
     * Creates multiple assets corresponding to products using master asset 
     * 
     * @param products list of paths for commerce products
     * @param master asset for which print mapping is already defined as a rendition
     * @param parent parent resource where new assets are to be created
     * 
     * @return a list of assets created as a copy from master asset & correspoding product
     */
    List<Asset> createPages(List<String> products, Asset master, Resource parent ) throws PersistenceException {
		return null;
	}
    
    /**
     * Creates a brochure using multiple assets 
     * 
     * @param pages ordered list of assets to be part of brochure
     * @param parent parent resource where new assets are to be created
     * @param mergedType Template or Catalog ?
     * @return a asset representing brochure
     */
    Asset createCatalog(String name, List<Asset> pages,String mergedType, Resource parent ) throws PersistenceException {
		return null;
	}
    /**
     * Creates a brochure using multiple assets
     * @Deprecated This method is no longer available, is replace by  createCatalog(String name, List<Asset> pages,String mergedType, Resource parent )
     * @param pages ordered list of assets to be part of brochure
     * @param parent parent resource where new assets are to be created
     * @return a asset representing brochure
     */
    Asset createCatalog(String name, List<Asset> pages, Resource parent ) throws PersistenceException {
		return null;
	}

}
