/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.jmx.annotation;

import javax.management.MBeanAttributeInfo;
import javax.management.MBeanConstructorInfo;
import javax.management.MBeanInfo;
import javax.management.MBeanOperationInfo;
import javax.management.MBeanParameterInfo;
import javax.management.NotCompliantMBeanException;
import javax.management.openmbean.OpenMBeanAttributeInfo;
import javax.management.openmbean.OpenMBeanAttributeInfoSupport;
import javax.management.openmbean.OpenMBeanConstructorInfo;
import javax.management.openmbean.OpenMBeanConstructorInfoSupport;
import javax.management.openmbean.OpenMBeanInfoSupport;
import javax.management.openmbean.OpenMBeanOperationInfo;
import javax.management.openmbean.OpenMBeanOperationInfoSupport;
import javax.management.openmbean.OpenMBeanParameterInfo;
import javax.management.openmbean.OpenMBeanParameterInfoSupport;
import javax.management.openmbean.OpenType;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * The extension of {@link AnnotatedStandardMBean} that will generate
 * {@link javax.management.openmbean.OpenMBeanInfo}. If any exception occur
 * during generation, then {@link MBeanInfo} generated by the parent class is
 * returned instead.
 * <p>
 * This implementation will look for the required {@link OpenTypeInfo}
 * annotation if the data type of attribute, operation or constructor is
 * {@link javax.management.openmbean.CompositeData} or
 * {@link javax.management.openmbean.TabularData}. This annotation will provide
 * a class that will be a template to generate the respective
 * {@link javax.management.openmbean.CompositeType} or
 * {@link javax.management.openmbean.TabularType}.
 * 
 * @see javax.management.openmbean.OpenMBeanInfo
 * @see AnnotatedStandardMBean
 * @see OpenTypeInfo
 * @see TabularTypeInfo
 */
public class OpenAnnotatedStandardMBean extends AnnotatedStandardMBean {
    private static final Logger log = LoggerFactory.getLogger(OpenAnnotatedStandardMBean.class);

    public <T> OpenAnnotatedStandardMBean(T implementation,
            Class<T> mbeanInterface) throws NotCompliantMBeanException {
        super(implementation, mbeanInterface);
    }
    
    protected OpenAnnotatedStandardMBean(Class<?> mbeanInterface)
            throws NotCompliantMBeanException {
        super(mbeanInterface);
    }

    @Override
    public MBeanInfo getMBeanInfo() {
		return null;
	}

    private OpenMBeanAttributeInfo convert(MBeanAttributeInfo info)
            throws Exception {
				return null;
			}

    private OpenMBeanConstructorInfo convert(MBeanConstructorInfo info)
            throws Exception {
				return null;
			}

    private OpenMBeanOperationInfo convert(MBeanOperationInfo info)
            throws Exception {
				return null;
			}

    private OpenMBeanParameterInfo convert(MBeanConstructorInfo ctor,
            MBeanParameterInfo info, int seq) throws Exception {
				return null;
			}

    private OpenMBeanParameterInfo convert(MBeanOperationInfo op,
            MBeanParameterInfo info, int seq) throws Exception {
				return null;
			}

    private Class<?> getClass(String type) throws ClassNotFoundException {
		return null;
	}

}
