/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2017 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.ui.components.rendercondition;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import javax.servlet.ServletException;

import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;

import com.adobe.granite.ui.components.impl.SlingIncludeObjectFactory;

/**
 * A helper to get {@code RenderCondition} of a resource.
 */
public class RenderConditionHelper {
    private static final String NAME_RENDERCONDITION = "granite:rendercondition";
    private static final String ATTRIBUTE_CACHE_RC = RenderConditionHelper.class.getName();

    private SlingHttpServletRequest request;
    private SlingHttpServletResponse response;

    public RenderConditionHelper(SlingHttpServletRequest request, SlingHttpServletResponse response) {
        this.request = request;
        this.response = response;
    }

    /**
     * Returns the render condition of the given resource.
     *
     * The render condition is specified by <code>granite:rendercondition</code> subresource.
     *
     * This method is an overload of {@link #getRenderCondition(Resource, boolean)} with cache = false.
     *
     * @param resource
     *            The resource whose render condition needs to be fetched
     *
     * @return The render condition; never <code>null</code>
     *
     * @throws ServletException
     *             When there's a servlet error during include
     * @throws IOException
     *             When there's an I/O error during include
     */
    public RenderCondition getRenderCondition(Resource resource) throws ServletException, IOException {
		return null;
	}

    /**
     * Returns the render condition of the given resource.
     *
     * The render condition is specified by <code>granite:rendercondition</code> subresource.
     *
     * @param resource
     *            The resource whose render condition needs to be fetched
     * @param cache
     *            <code>true</code> to cache the result; Use it when checking render condition of other resource
     *            (typically the item resource) so that the render condition is only resolved once.
     *
     * @return The render condition; never <code>null</code>
     *
     * @throws ServletException
     *             When there's a servlet error during include
     * @throws IOException
     *             When there's an I/O error during include
     */
    public RenderCondition getRenderCondition(Resource resource, boolean cache) throws ServletException, IOException {
		return null;
	}

    private Map<String, RenderCondition> getRenderConditionCache() {
		return null;
	}

    private static String getResourceType(Resource resource) {
		return null;
	}
}
