/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.workflow.job;

/**
 * Proxy to implementations of the AbsoluteTimeoutHandler interface
 *
 * @see AbsoluteTimeoutHandler
 */
public interface AbsoluteTimeoutHandlerProxy {
    /**
     * Returns a AbsoluteTimeoutHandler if this proxy can handle the request identified by the parameter.
     * @param absoluteTimeoutHandlerName name to identify the AbsoluteTimeoutHandler.
     * @return an AbsoluteTimeoutHandler if this proxy can handle the provided name, null otherwise.
     */
    AbsoluteTimeoutHandler findHandler(String absoluteTimeoutHandlerName) {
		return null;
	}
}
