/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.workflow.model;

import com.adobe.granite.workflow.WorkflowException;

/**
 * VersionException is thrown on errors related to the versioning of workflow models.
 */
public class VersionException extends WorkflowException {
    /**
     * Constructs a new VersionException with message and cause.
     * @param message the message related to this exception.
     * @param cause the cause of this exception.
     */
    public VersionException(String message, Throwable cause) {
        super(message, cause);
    }

    /**
     * Constructs a new VersionException with a message.
     * @param message the message related to this exception.
     */
    public VersionException(String message) {
        super(message);
    }
}
