/**
 * ADOBE SYSTEMS INCORPORATED
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 * NOTICE:  Adobe permits you to use, modify, and distribute this file in accordance with the
 * terms of the Adobe license agreement accompanying it.  If you have received this file from a
 * source other than Adobe, then your use, modification, or distribution of it requires the prior
 * written permission of Adobe.
 */
package com.adobe.social.integrations.livefyre.config.api;

import java.util.List;

import javax.annotation.Nonnull;

import org.apache.sling.api.resource.Resource;

import com.adobe.cq.social.SocialException;

/**
 * Service interface to get Livefyre configurations.
 * @author mcweeney
 */
public interface LivefyreConfigProvider {
    String PROPERTY_NETWORK_DOMAIN = "communities.integration.livefyre.networkdomain";
    String PROPERTY_NETWORK_KEY = "communities.integration.livefyre.networkkey";
    String PROPERTY_SITE_ID = "communities.integration.livefyre.siteid";
    String PROPERTY_SITE_KEY = "communities.integration.livefyre.sitekey";
    String PROPERTY_CONFIG_CACHE_TTL = "communities.integration.livefyre.cachettl";

    /**
     * Gets a configuration based on the resource. This config lives now at the OSGI container level but will likely
     * move, "lower"
     * @param resource the resource to get a configuration for
     * @return the LiveFyre configuration object
     * @throws SocialException when Livefyre is not configured properly
     */
    @Nonnull
    LivefyreConfig getConfig(final Resource resource) throws SocialException {
		return null;
	}

    List<LivefyreConfig> getAllConfigs() throws SocialException {
		return null;
	}
}
