/**
 * ADOBE SYSTEMS INCORPORATED
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 * NOTICE:  Adobe permits you to use, modify, and distribute this file in accordance with the
 * terms of the Adobe license agreement accompanying it.  If you have received this file from a
 * source other than Adobe, then your use, modification, or distribution of it requires the prior
 * written permission of Adobe.
 */
package com.adobe.social.integrations.livefyre.user.api;

import com.adobe.cq.social.scf.User;
import com.fasterxml.jackson.annotation.JsonIgnore;

public interface LivefyreUser extends User {

    /**
     * Gets the safely encoded Livefyre ID that will be shared with Livefyre.
     * @return the Livefyre safe ID
     */
    @JsonIgnore
    String getLivefyreId() {
		return null;
	}

    /**
     * Gets the Livefyre token to be used to authenticate this user.
     * @return the token, unless the requestor is not the user then null to protect leakage of tokens
     */
    String getLftoken() {
		return null;
	}
}
