/**
 * ADOBE SYSTEMS INCORPORATED
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 * NOTICE:  Adobe permits you to use, modify, and distribute this file in accordance with the
 * terms of the Adobe license agreement accompanying it.  If you have received this file from a
 * source other than Adobe, then your use, modification, or distribution of it requires the prior
 * written permission of Adobe.
 */
package com.adobe.social.integrations.livefyre.user.api;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

import com.adobe.cq.social.scf.ClientUtilities;
import com.adobe.cq.social.scf.SocialComponentFactory;
import com.adobe.granite.security.user.UserProperties;
import com.adobe.social.integrations.livefyre.user.impl.LivefyreUserImpl;

public interface PingForPullUserComponentFactory extends SocialComponentFactory {
    /**
     * Gets the Ping for Pull user to pass to Livefyre when a Ping for Pull occurs.
     * @param user the Livefyre user object to serialize @see
     *            /aem-livefyre/src/main/java/com/adobe/social/integrations/livefyre/user/impl/LiveFyreUser.java
     * @param clientUtils
     * @param userProps
     * @return a user object ready to be sent back to Livefyre with the required fields
     */
    PingForPullUser getPingForPullUser(@Nonnull final LivefyreUser user, @Nonnull final ClientUtilities clientUtils,
        @Nullable final UserProperties userProps) {
		return null;
	}
}
