// =================================================================================================
// ADOBE SYSTEMS INCORPORATED
// Copyright 2012 Adobe Systems Incorporated
// All Rights Reserved
//
// NOTICE:  Adobe permits you to use, modify, and distribute this file in accordance with the terms
// of the Adobe license agreement accompanying it.
// =================================================================================================
package com.adobe.xmp.core.parser;

import com.adobe.xmp.core.XMPException;


/**
 * Exception for parsing failures resulting due to non-adherence to XMP specification.
 */
@SuppressWarnings("serial")
public class ParseXMPException extends XMPException
{

	/**
	 * Constructor with argument for this exception
	 * 
	 * @param errorMsg an explaining message
	 * @see XMPException#XMPException(String, Throwable)
	 */
	public ParseXMPException(String errorMsg)
	{
		super(errorMsg);
	}
	
}
