/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and may be covered by U.S. and Foreign Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.analytics.sitecatalyst;

import org.apache.sling.api.resource.Resource;

import com.adobe.cq.scheduled.exporter.Transformer;

/**
 * Is a specific interface extending
 * {@link com.adobe.cq.scheduled.exporter.Transformer} for transforming
 * resources in preparation for export as Classifications for Analytics. The
 * interface uses the String[] type.
 * 
 * @since 6.1
 */
public interface ClassificationsTransformer extends Transformer<String[]> {

    /**
     * Returns a String[] of header keys from a <code>resource</code>. The first
     * value will be 'Key' as defined by Analytics. The other values are
     * non-namespace property names of the <code>resource</code>. Please note
     * that the {@link ClassificationsTransformer#transform(Resource)} method
     * needs to return its values in the exact same order as defined in the
     * header.
     * @param resource resource to extract the headerkeys from
     * 
     * @return Header column keys, starting with 'Key' as first value.
     */
    String[] getHeader(Resource resource) {
		return null;
	}

}
