/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.analytics.testandtarget;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.day.cq.analytics.testandtarget.impl.serializer.PerformanceReportSerializer;

/**
 * The <tt>PerformanceReport</tt> contains performance reporting data about a single campaign
 *
 */
public class PerformanceReport {

    private static final Logger LOG = LoggerFactory.getLogger(PerformanceReport.class);

    private List<PerformanceReportItem> items = new ArrayList<PerformanceReportItem>();

    private PerformanceReportItem totals = null;

    private String winningExperienceName = "";

    /**
     * Adds a {@link PerformanceReportItem}
     * @param item the item instance to add, must not be <code>null</code>
     */
    public void addItem(PerformanceReportItem item) {
	}

    /**
     * Returns a list of {@link PerformanceReportItem}
     * @return an unmodifiable view over the experiences contained in this report
     */
    public List<PerformanceReportItem> getItems() {
		return null;
	}

    /**
     * Sets the winning experience local id.
     * @param experienceName a <code>String</code> value representing the name of the winning experience
     */
    public void setWinningExperienceName(String experienceName) {
	}

    /**
     * Retrieves the name of the winning experience or an empty string if there is no winning experience in
     * the report
     * @return a string representation of the winning experience
     */
    public String getWinningExperienceName() {
		return null;
	}
    /**
     * Returns the total performance for all experience contained in this report
     * 
     * <p>
     * The <tt>name</tt> field will always be set to null
     * </p>
     * 
     * @return the total performance for all experience contained in this report
     */
    public PerformanceReportItem getTotalPerformance() {
		return null;
	}
}
