/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.analytics.testandtarget;

/**
 * The <tt>PerformanceReportItem</tt> is an entry in a {@link PerformanceReport}
 */
public class PerformanceReportItem {

    private String experienceName;
    private int entryCount;
    private int conversionCount;
    private double conversionRate;
    private double lift;
    private double confidence;
    private double engagement;
    private double engagementTotal;
    private int engagementCount;

    private String revenuePerVisitor;
    private String averageOrderValue;
    private String totalSales;

    /**
     * Returns the name of the experience
     * 
     * @return the name of the experience, possibly <code>null</code> if this item represents the aggregated report data
     */
    public String getExperienceName() {
		return null;
	}

    /**
     * Sets the specified {@code experienceName}.
     * 
     * @param experienceName string representation of the experience name
     */
    public void setExperienceName(String experienceName) {
	}

    /**
     * Returns the number of entries for this item.
     * 
     * @return the number of entries
     */
    public int getEntryCount() {
		return 0;
	}

    /**
     * Sets the number of entries for this item.
     * 
     * @param entryCount the number of entries
     */
    public void setEntryCount(int entryCount) {
	}

    /**
     * Returns the number of conversions for this item.
     * 
     * @return the number of conversions
     */
    public int getConversionCount() {
		return 0;
	}

    /**
     * Sets the number of conversions for this item.
     * 
     * @param conversionCount the number of conversions
     */
    public void setConversionCount(int conversionCount) {
	}

    /**
     * Getter and setter for the conversion rate field.
     * 
     * @return the conversion rate
     */
    public double getConversionRate() {
		return 0.0d;
	}

    /**
     * Sets the conversion rate.
     * 
     * @param conversionRate conversion rate
     */
    public void setConversionRate(double conversionRate) {
	}

    /**
     * Gets the lift value.
     * 
     * @return the lift
     */
    public double getLift() {
		return 0.0d;
	}

    /**
     * Sets the lift value.
     * 
     * @param lift the lift
     */
    public void setLift(double lift) {
	}

    /**
     * Gets the confidence.
     * 
     * @return the confidence
     */
    public double getConfidence() {
		return 0.0d;
	}

    /**
     * Sets the confidence.
     * 
     * @param confidence the confidence
     */
    public void setConfidence(double confidence) {
	}

    /**
     * Gets the engagement.
     * 
     * @return the engagement
     */
    public double getEngagement() {
		return 0.0d;
	}

    /**
     * Sets the engagement.
     * 
     * @param engagement the engagement
     */
    public void setEngagement(double engagement) {
	}

    /**
     * Gets the engagement count.
     * 
     * @return the engagement count
     */
    public int getEngagementCount() {
		return 0;
	}

    /**
     * Gets the engagement count.
     * 
     * @param engagementCount the engagement count
     */
    public void setEngagementCount(int engagementCount) {
	}

    /**
     * Gets the engagement total.
     * 
     * @return the engagement total
     */
    public double getEngagementTotal() {
		return 0.0d;
	}

    /**
     * Sets the engagement total.
     * 
     * @param engagementTotal the engagement total
     */
    public void setEngagementTotal(double engagementTotal) {
	}

    /**
     * Gets the revenue per visitor.
     * 
     * @return the revenue per visitor
     */
    public String getRPV() {
		return null;
	}

    /**
     * Sets the revenue per visitor.
     * 
     * @param revenuePerVisitor the revenue per visitor
     */
    public void setRPV(String revenuePerVisitor) {
	}

    /**
     * Gets the average order value.
     * 
     * @return the average order value
     */
    public String getAOV() {
		return null;
	}

    /**
     * Sets the average order value.
     * 
     * @param averageOrderValue the average order value
     */
    public void setAOV(String averageOrderValue) {
	}

    /**
     * Gets the total sales.
     * 
     * @return the total sales
     */
    public String getTotalSales() {
		return null;
	}

    /**
     * Sets the total sales.
     * 
     * @param totalSales the total sales
     */
    public void setTotalSales(String totalSales) {
	}
}