/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.analytics.testandtarget;

import java.util.Date;
import java.util.Map;

/**
 * A segment, as it is represented in Adobe Target
 * 
 * <p>
 * The properties of a segment are exactly those returned by the Adobe Target API, with no modification.
 * </p>
 * 
 */
public class Segment {

    private long id;
    private String path;
    private String name;
    private String description;
    private String segmentRule;
    private Date createdAt;
    private String createdBy;
    private Date modifiedAt;
    private String modifiedBy;
    private String origin;
    private boolean hidden;
    private String type;
    private Map<String, String> marketingCloudMetadata;

    public long getId() {
		return 0L;
	}

    public void setId(long id) {
	}

    public String getPath() {
		return null;
	}

    public void setPath(String path) {
	}

    public String getName() {
		return null;
	}

    public void setName(String name) {
	}

    public String getDescription() {
		return null;
	}

    public void setDescription(String description) {
	}

    public String getSegmentRule() {
		return null;
	}

    public void setSegmentRule(String segmentRule) {
	}

    public Date getCreated() {
		return null;
	}

    public void setCreated(Date created) {
	}

    public String getCreatedBy() {
		return null;
	}

    public void setCreatedBy(String createdBy) {
	}

    public Date getModified() {
		return null;
	}

    public void setModified(Date modified) {
	}

    public String getModifiedBy() {
		return null;
	}

    public void setModifiedBy(String modifiedBy) {
	}

    public boolean getHidden() {
		return false;
	}

    public void setHidden(boolean hidden) {
	}

    /**
     * Segment type [reusable|anonymous]
     * Present starting with TnT segments API v7
     * @since AEM 6.2
     *
     * @return segment type {@code String}
     */
    public String getType() {
		return null;
	}

    public void setType(String type) {
	}

    /**
     * Segment metadata information
     * Contains following information keys: sourceProductName, editURL, remoteModifiedBy
     * Present starting with TnT segments API v7
     * @since AEM 6.2
     *
     * @return metadata information {@code Map}
     */
    public Map<String, String> getMarketingCloudMetadata() {
		return null;
	}

    public void setMarketingCloudMetadata(Map<String, String> metadata) {
	}

    /**
     * Returns this segments's source, i.e. the solution that contributed it to Target (could be AAM, Bullseye or
     * Target itself)
     * @return a {@link String} object representing the source. This string representation is the one from Target
     * with no formatting applied. It's the caller's job to map this source name to actual solution names (e.g. for
     * Target the source is {@code tnt})
     */
    public String getSource() {
		return null;
	}

    public void setSource(String source) {
	}

    @Override
    public String toString() {
		return null;
	}

}
