/*
 * Copyright 1997-2009 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.dam.commons.handler;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import com.adobe.xmp.XMPException;
import com.adobe.xmp.XMPMetaFactory;
import com.day.cq.dam.api.Context;
import com.day.cq.dam.api.Processor;
import com.day.cq.dam.api.ProcessorException;

/**
 * Process bytes, extract metadata found in &lt;xpacket&gt; tags and add them to
 * a {@link Context}.
 *
 * @author dpfister
 */
public class XMPProcessor implements Processor, FilterStateListener {

    /**
     * Context.
     */
    private Context context;

    /**
     * Top filter we're passing bytes to.
     */
    private XPacketFilter topFilter;

    /**
     * Create a new instance of this class.
     *
     * @param context context
     */
    public XMPProcessor(Context context) {
        this.context = context;

        topFilter = new XPacketFilter();
        topFilter.setFilterStateListener(this);
        topFilter.setAutoReset(true);
    }

    //---------------------------------------------------------------- Processor

    /**
     * {@inheritDoc}
     */
    public final void process(byte[] buf, int off, int len) throws IOException {
	}

    //------------------------------------------------------ FilterStateListener

    /**
     * {@inheritDoc}
     */
    public OutputStream started(Filter filter) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public void ended(Filter filter, OutputStream out) {
	}

    /**
     * Utility method that processes an input stream and returns the first
     * valid XMP input stream.
     *
     * @param in input stream
     * @throws IOException if an I/O error occurs
     * @throws ProcessorException if a processor error occurs
     */
    public static InputStream process(InputStream in)
            throws IOException, ProcessorException {
				return null;
			}
}
