/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.day.cq.dam.commons.util;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import javax.jcr.RepositoryException;

import com.adobe.granite.confmgr.Conf;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.jcr.resource.api.JcrResourceConstants;
import org.apache.sling.tenant.Tenant;

import com.day.cq.commons.jcr.JcrConstants;
import com.day.cq.dam.api.DamConstants;
import com.day.cq.dam.commons.schemaforms.internal.TabList;
import com.day.text.Text;

/**
 * this is an internal class to be used by dam code.
 */
public class SchemaFormHelper {

    /**
     * Given current form, returns a list of master.
     * Looks for master forms up in the path heirarchy,
     * while traversing it takes into account any override
     * available in apps
     *
     * @param currentForm current form resource
     * @return list of master form resource, empty list if no master is found
     * @throws RepositoryException
     */
    @Deprecated
    public static List<Resource> getMasterForms(Resource currentForm, String formsBaseDirPath) throws RepositoryException {
		return null;
	}

    /**
     * @return Metadata Schema provides a OOTB form. And User can overlay this form as per use case.
     * It returns list of form path homes (Overlay, OOTB) in the order. e.g. [/conf/metdataschema, /libs/metadataschema]
     */
    public static String[] getBaseFormPaths(ResourceResolver resourceResolver){
		return null;
	}

    /**
     * retruns relatibe path of the form '/default/image'
     * @param formPath
     * @param baseFormPaths
     * @return
     */
    private static String getRelativeFormPath(String formPath, String[] baseFormPaths){
		return null;
	}

    /**
     * Given current form, returns a list of master.
     * Looks for master forms up in the path heirarchy,
     * while traversing it takes into account any override
     * available in apps
     *
     * @param currentForm current form resource
     * @return list of master form resource, empty list if no master is found
     * @throws RepositoryException
     * @throws java.lang.NullPointerException
     */
    public static List<Resource> getMasterForms(Resource currentForm) throws RepositoryException {
		return null;
	}



    /**
     * Merge two list of tabs i.e. form/items/tabs
     *
     * @param oneTabList   resource representing one tab list
     * @param otherTabList resource representing other tab list
     * @return merged tab list resource
     */
    public static Resource mergeFormTabResource(Resource oneTabList, Resource otherTabList) {
		return null;
	}

    public static Resource getSchemaResource(SlingHttpServletRequest request) {
		return null;
	}

    private static String getAppsDir(ResourceResolver resolver) {
		return null;
	}

    public static Iterator getSchemaFormsIterator(SlingHttpServletRequest request, int rows, int offset) {
		return null;
	}
    
    public static Iterator getSchemaFormsIterator(ResourceResolver resolver, String suffix, int rows, int offset){
		return null;
	}

}
