package com.day.cq.dam.commons.watermark;

import com.day.image.Layer;

import java.awt.*;
import java.awt.font.FontRenderContext;
import java.awt.font.TextAttribute;
import java.awt.font.TextLayout;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.text.AttributedCharacterIterator;
import java.text.AttributedString;

/**
 *  A {@link TextWatermark} represents a string of text to be used to watermark an underlying image.<br/>
 *  While actually applying the watermark effect,
 *  the styled text is converted to an image so that the effect is uniform.
 */
public class TextWatermark extends ImageWatermark {

    public static final String COPYRIGHT = "\u00a9";

    private String text;

    private Font font;

    private boolean vertical;

    public TextWatermark(String text) {
        this.text = text;
        this.font = new Font();
    }

    public TextWatermark(String text, Font font) {
        this.text = text;
        this.font = font;
    }

    public TextWatermark(Location position, double orientation, float opacity, String text, Font font) {
        super(position, orientation, opacity);
        this.text = text;
        this.font = font;
    }

    public TextWatermark(int top, int left, double orientation, float opacity, String text, Font font) {
        super(top, left, orientation, opacity);
        this.text = text;
        this.font = font;
    }

    public TextWatermark(Location position, String text, Font font) {
        super(position);
        this.text = text;
        this.font = font;
    }

    public TextWatermark(int top, int left, String text, Font font) {
        super(top, left);
        this.text = text;
        this.font = font;
    }

    public String getText() {
		return null;
	}

    public void setText(String text) {
	}

    public Font getFont() {
		return null;
	}

    public void setFont(Font font) {
	}

    /**
     * Generates a transparent image representing the text of this watermark.
     * Text in the image will abide by the font specifications.
     *
     * @return  the {@link BufferedImage} object thus produced
     */
    @Override
    public BufferedImage getImage() {
		return null;
	}

    @Override
    public String toString() {
		return null;
	}

    public boolean isVertical() {
		return false;
	}

    public void setVertical(boolean vertical) {
	}
}