/*
 * Copyright 1997-2010 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.dam.video;

import com.day.cq.dam.api.Asset;
import com.day.cq.dam.handler.ffmpeg.FFMpegWrapper;
import com.day.image.Layer;
import org.apache.commons.io.IOUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.LinkedList;
import java.util.List;

import static com.day.cq.dam.api.DamConstants.THUMBNAIL_MIMETYPE;

/**
 * <code>StoryBoard</code>...
 */
public class StoryBoard {

    private static final Logger log = LoggerFactory.getLogger(StoryBoard.class);

    private final List<String> framesList = new LinkedList<String>();

    private final FFMpegWrapper wrapper;
    private final Asset asset;

    private int frames = 10;
    private int start = 0;
    private int maxWidth = 320;
    private int maxHeight = 240;
    private boolean upscale = true;

    public StoryBoard(final FFMpegWrapper wrapper, final Asset asset) {
        this.wrapper = wrapper;
        this.asset = asset;

        if (null == wrapper) {
            throw new IllegalArgumentException("wrapper may not be null");
        }

        if (null == asset) {
            throw new IllegalArgumentException("asset may not be null");
        }
    }

    public void setFrames(final int frames) {
	}

    public void setStart(final int start) {
	}

    public void setMaxWidth(final int maxWidth) {
	}

    public void setMaxHeight(final int maxHeight) {
	}

    public void setUpscale(final boolean upscale) {
	}

    public synchronized void addFrame(final String config) {
	}

    public void create() throws IOException {
	}
}
