/*
 * Copyright 1997-2004 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.graphics.chart;

import java.awt.Rectangle;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.NoSuchElementException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.day.cq.graphics.Graph;
import com.day.image.Layer;

/**
 * Implementations extend this
 *
 * @author tripod
 */
// todo: we should have some sort of SPI interface for this
public abstract class Chart {

    /** default logging */
    private final static Logger log = LoggerFactory.getLogger(Chart.class);

    public static final HashMap<String, Class<?>> chartTypes = new HashMap<String, Class<?>>();

    Rectangle position;

    static {
    	registerChartType(LineChart.class);
    	registerChartType(BarChart.class);
    	registerChartType(PieChart.class);
    }

    protected static synchronized void registerChartType(Class<?> chartClass) {
	}

    /**
     * Returns the identification name of the chart
     * @return the  identification name of the chart
     */
    public static String getName() {
		return null;
	}


    protected Chart() {
    }

    public static Chart getInstance(String typeName) throws NoSuchElementException {
		return null;
	}

    public abstract Layer draw(Graph graph, boolean doDraw) {
		return null;
	}
}
