/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.mcm.api;

import java.util.Collection;
import java.util.HashMap;

import org.apache.sling.api.resource.Resource;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.day.cq.mcm.util.NormalizedResource;

/**
 * Helps when implementing {@link MCMPlugin}.
 * Provides the root component functionality with a list of components manageable
 * via {@link #addExperienceComponent(String, Factory)} and {@link #addTouchpointComponent(String, Factory)}. 
 * You can also add only one (Experience or touchpoint), or many.
 */
public abstract class MCMPluginAdapter implements MCMPlugin {

	private final static Logger log = LoggerFactory.getLogger(MCMPluginAdapter.class);
	
	public static interface Factory<T> {
		public T create(Resource r) {
			return null;
		}
	}
	
	private HashMap<String, Factory<Experience>> experienceFactoryMap = new HashMap<String, Factory<Experience>>();
	
	private HashMap<String, Factory<Touchpoint>> touchpointFactoryMap = new HashMap<String, Factory<Touchpoint>>();
	
	public MCMPluginAdapter() {
		super();
	}
	
	/**
	 * Returns the comptypes that were registered with {@link #addTouchpointComponent(String, Factory)}. 
	 */
	public Collection<String> getTouchpointRootComponents() {
		return null;
	}
	
	/**
	 * Returns the comptypes that were registered with {@link #addExperienceComponent(String, Factory)}.
	 */
	public Collection<String> getExperienceRootComponents() {
		return null;
	}
	
	/**
	 * Use this to add your types to the adapter.
	 * @param compType
	 * @param fac
	 */
	protected void addExperienceComponent(String compType, Factory<Experience> fac) {
	}
	
	/**
	 * Use this to add your types to the adapter.
	 * @param compType
	 * @param fac
	 */
	protected void addTouchpointComponent(String compType, Factory<Touchpoint> fac) {
	}

	public Experience makeExperience(Resource adaptable) {
		return null;
	}

	public Touchpoint makeTouchpoint(Resource adaptable) {
		return null;
	}

	private String extractCompType(Resource adaptable) {
		return null;
	}
	
	@Override
	public String toString() {
		return null;
	}
}
