/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.personalization.ui.items;

import java.util.Set;

/**
 * Represents an interface for the offers page meta component which implements
 * the Granite UI 'foundation-collection-meta' behavior.
 */
public interface OfferPageMeta {

    /**
     * Returns the title of the suffix resource.
     * 
     * @return Resource title
     */
    String getTitle() {
		return null;
	}

    /**
     * Returns {@code true} if the current suffix resource is a folder.
     * 
     * @return {@code true} if suffix resource is a folder, {@code false} otherwise
     */
    boolean isFolder() {
		return false;
	}

    /**
     * Returns a set of action relations which apply to the suffix resource.
     * 
     * @return A set of relation identifiers
     */
    Set<String> getActionRels() {
		return null;
	}

}
