/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.day.cq.replication;

/**
 * This exception is thrown when the path to replicate is not found.
 */
public class PathNotFoundException extends ReplicationException {

    private static final long serialVersionUID = -5930202957795016152L;

    /**
     * Creates a <code>PathNotFoundException</code> given
     * a message describing the failure cause
     * @param s description
     */
    public PathNotFoundException(String s) {
        super(s);
    }

    /**
     * Creates a <code>PathNotFoundException</code> given
     * a message describing the failure cause and a root
     * exception
     * @param s description
     * @param e root failure cause
     */
    public PathNotFoundException(String s, Exception e) {
        super(s, e);
    }

    /**
     * Creates a <code>PathNotFoundException</code> given
     * a root exception
     * @param e root failure cause
     */
    public PathNotFoundException(Exception e) {
        super(e);
    }
}
