/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.rewriter.linkchecker;

import java.util.Calendar;
import java.util.HashSet;
import java.util.Set;

/**
 * Stores information about the validity of an external link.
 */
public class LinkInfo {

    public static final int X_STATUS_NOT_CHECKED = 0;
    public static final int X_STATUS_UNSUPPORTED = -1;
    public static final int X_STATUS_URI_SYNTAX_ERROR = -2;
    public static final int X_STATUS_CONNECT_ERROR = -3;
    public static final int X_STATUS_NO_ROUTE_TO_HOST = -4;
    public static final int X_STATUS_UNKOWN_HOST = -5;
    public static final int X_STATUS_IO_ERROR = -6;
    public static final int X_STATUS_SSL_ERROR = -7;

    private final String url;
    private Calendar lastChecked;
    private Calendar lastAccessed;
    private Calendar lastAvailable;
    private boolean valid;
    private int lastStatus;
    private final Set<String> referencedBy = new HashSet<String>();

    /**
     * Initializes a new instance.
     *
     * @param url The URL to store validity information about
     */
    public LinkInfo(String url) {
        this.url = url;
        this.lastAccessed = Calendar.getInstance();
        valid = true;
    }

    /**
     * Initializes a new instance based on the given one.
     * @param base info to copy from
     */
    public LinkInfo(LinkInfo base) {
        url = base.url;
        lastChecked = base.lastChecked;
        lastAccessed = base.lastAccessed;
        lastAvailable = base.lastAvailable;
        lastStatus = base.lastStatus;
        valid = base.valid;
        referencedBy.addAll(base.referencedBy);
    }

    /**
     * Returns the date a check for validity of the URL has last been requested.
     *
     * @return The date the check for validity of the URL has last been requested
     */
    public Calendar getLastAccessed() {
		return null;
	}

    /**
     * Sets the date a check for validity of the URL has last been requested.
     *
     * @param lastAccessed The date the check for validity of the URL has last been requested
     */
    public void setLastAccessed(Calendar lastAccessed) {
	}

    /**
     * Returns the date the URL has last been checked by the asynchronous LinkCheckerTask.
     *
     * @return The date the URL has last been checked
     */
    public Calendar getLastChecked() {
		return null;
	}

    /**
     * Sets the date the URL has last been checked by the asynchronous LinkCheckerTask.
     *
     * @param lastChecked The date the URL has last been checked
     */
    public void setLastChecked(Calendar lastChecked) {
	}

    /**
     * Returns the date the resource described by the URL has last been available.
     *
     * @return The date the resource described by the URL has last been available.
     */
    public Calendar getLastAvailable() {
		return null;
	}

    /**
     * Sets the date the resource described by the URL has last been available.
     *
     * @param lastAvailable The date the resource described by the URL has last been available.
     */
    public void setLastAvailable(Calendar lastAvailable) {
	}

    /**
     * Returns the URL about which validity information is stored.
     *
     * @return The URL about which validity information is stored
     */
    public String getUrl() {
		return null;
	}

    /**
     * Returns whether the resource described by the URL is currently available.
     *
     * @return true, if the resource described by the URL is currently available
     */
    public boolean isValid() {
		return false;
	}

    /**
     * Sets whether the resource described by the URL is currently available.
     *
     * @param valid Whether the resource described by the URL is currently available
     */
    public void setValid(boolean valid) {
	}

    /**
     * Returns the last status
     * @return the last status
     */
    public int getLastStatus() {
		return 0;
	}

    public String getLastStatusAsString() {
		return null;
	}

    /**
     * Sets the last status
     * @param lastStatus the last status
     */
    public void setLastStatus(int lastStatus) {
	}

    /**
     * Adds (if not already present) a referrer to this link.
     * @param path the path of the node referencing this link
     */
    public void addReferrer(String path) {
	}

    /**
     * Returns the paths referencing this link
     * @return the paths referencing this link
     */
    public String[] getReferrer() {
		return null;
	}

    @Override
    public boolean equals(Object o) {
		return false;
	}

    public boolean isSame(LinkInfo linkInfo) {
		return false;
	}

    @Override
    public int hashCode() {
		return 0;
	}
}
