/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 **************************************************************************/
package com.day.cq.wcm.api;

import aQute.bnd.annotation.ProviderType;
import com.day.cq.wcm.api.components.ComponentContext;
import org.apache.commons.collections.Predicate;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ValueMap;

import java.util.List;

/**
 * Template Manger API.
 *
 * API for managing 'authored' templates and related components.
 */
@ProviderType
public interface TemplateManager {

    /**
     * Creates a new template
     * @param parentPath the parent path
     * @param templateName the template name
     * @param templateProperties properties of template
     * @param templateType type of template
     * @return Template
     * @throws WCMException is thrown if the template is still used on pages.
     */
    public Template createTemplate(String parentPath, String templateType, String templateName, ValueMap templateProperties) throws WCMException {
		return null;
	}

    /**
     * @param template the template
     *
     * @throws com.day.cq.wcm.api.WCMException is thrown if the template is still used on pages.
     */
    public void deleteTemplate(Template template) throws WCMException {
	}

    /**
     * @param template the template
     *
     * @return Containing Pages
     */
    public List<Page> getContainingPages(Template template) {
		return null;
	}


    /**
     * @param componentContext the component context
     *
     * @return list of structureResources
     */
    public List<Resource> getStructureResources(ComponentContext componentContext) {
		return null;
	}

    /**
     * @param resource the resource that contains template
     *
     * @return Template
     */
    public Template getContainingTemplate(Resource resource) {
		return null;
	}

    /**
     * @return List of All Templates
     */
    public List<Template> getAllTemplates() {
		return null;
	}


    /**
     * @param filter filter templates
     *
     * @return Get Filtered Templates
     */
    public List<Template> getTemplates(Predicate filter) {
		return null;
	}

    /**
     * @param templatePath the path for the template
     *
     * @return the template at the templatePath
     */
    public Template getTemplate(String templatePath) {
		return null;
	}

    /**
     * Get template types
     *  @param parentPath The parent path for the templates
     * @return Template type for each template
     */
    public List<Template> getTemplateTypes(String parentPath) {
		return null;
	}

}
