/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 **************************************************************************/
package com.day.cq.wcm.commons.policy;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import com.day.cq.wcm.api.designer.Cell;
import com.day.cq.wcm.api.designer.Design;
import com.day.cq.wcm.api.designer.Style;
import com.day.cq.wcm.api.policies.ContentPolicy;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ValueMap;
import org.apache.sling.api.wrappers.ValueMapDecorator;

/**
 * A compatibility wrapper using a content policy as a style.
 *
 * The goal is to use components using the currentStyle binding with the new content policies, without the need
 * to change the component. This will not be a complete style implementation but rather focuses on the reading
 * of the  map values.
 *
 * @since 6.1
 */
public class ContentPolicyStyle implements Style {

    private final ContentPolicy contentPolicy;

    private final Cell cell;

    private ValueMap properties;

    public ContentPolicyStyle(ContentPolicy contentPolicy, Cell cell) {
        if (contentPolicy == null) {
            throw new IllegalArgumentException("contentPolicy is null");
        }
        this.contentPolicy = contentPolicy;
        this.cell = cell;
    }

    private void initProperties() {
	}

    public Design getDesign() {
		return null;
	}

    public String getPath() {
		return null;
	}

    public Cell getCell() {
		return null;
	}

    public <T> T get(String name, Class<T> type) {
		return null;
	}

    public <T> T get(String name, T defaultValue) {
		return null;
	}

    public Resource getDefiningResource(String name) {
		return null;
	}

    public String getDefiningPath(String name) {
		return null;
	}

    public Style getSubStyle(String relPath) {
		return null;
	}

    public int size() {
		return 0;
	}

    public boolean isEmpty() {
		return false;
	}

    public boolean containsKey(Object o) {
		return false;
	}

    public boolean containsValue(Object o) {
		return false;
	}

    public Object get(Object o) {
		return null;
	}

    public Object put(String s, Object o) {
		return null;
	}

    public Object remove(Object o) {
		return null;
	}

    public void putAll(Map<? extends String, ?> map) {
	}

    public void clear() {
	}

    public Set<String> keySet() {
		return null;
	}

    public Collection<Object> values() {
		return null;
	}

    public Set<Entry<String, Object>> entrySet() {
		return null;
	}
}
