/*************************************************************************
 * ADOBE CONFIDENTIAL
 * __________________
 * <p/>
 * Copyright 2015 Adobe Systems Incorporated
 * All Rights Reserved.
 * <p/>
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
/**
 * AdobePatentID="P6273-US"
 */
package com.day.cq.wcm.foundation;

import com.adobe.cq.sightly.WCMUsePojo;
import com.day.cq.i18n.I18n;
import com.day.cq.wcm.api.Page;
import com.day.cq.wcm.api.Template;
import com.day.cq.wcm.api.TemplatedResource;
import com.day.cq.wcm.api.components.Component;
import com.day.cq.wcm.api.components.ComponentManager;
import com.day.cq.wcm.api.policies.ContentPolicy;
import com.day.cq.wcm.api.policies.ContentPolicyMapping;
import org.apache.commons.lang.StringUtils;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ValueMap;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;

public class AllowedComponentList extends WCMUsePojo {

    private static final String PLACEHOLDER_COMPONENT_PATH = "wcm/foundation/components/parsys/placeholder";
    private static final String PN_POLICY = "cq:policy";
    private static final String PN_COMPONENTS = "components";
    private static final String COMPONENT_GROUP_PREFIX = "group:";
    public static final String STRUCTURE_JCR_CONTENT = "/structure/jcr:content/";
    public static final String POLICIES_JCR_CONTENT = "/policies/jcr:content/";

    private Collection<Component> components;

    private String[] componentPaths = null;

    private class ComponentComparator implements Comparator<Component> {

        @Override
        public int compare(Component comp1, Component comp2) {
			return 0;
		}
    }

    public static class ComponentMapping {

        private String path;
        private String resourceType;
        private String cssClass;

        public ComponentMapping (String path, String resourceType, String cssClass) {
            this.path = path;
            this.resourceType = resourceType;
            this.cssClass = cssClass;
        }

        public String getPath() {
			return null;
		}

        public String getResourceType() {
			return null;
		}

        public String getCssClass() {
			return null;
		}
    }

    @Override
    public void activate() throws Exception {
	}

    public String getTitle() {
		return null;
	}

    /**
     * Is the allowed component list applicable in the current context
     *
     * @return
     */
    public boolean isApplicable () {
		return false;
	}

    /**
     * Returns the list of allowed components from the parent
     *
     * @return
     */
    private String[] getComponentPathList() {
		return null;
	}

    private String getRelativePath(Resource resource) {
		return null;
	}

    /**
     * Returns a list of Pojos for Sightly resource instantiation usage
     *
     * @return
     * @throws UnsupportedEncodingException
     */
    public List getComponents() throws UnsupportedEncodingException {
		return null;
	}

    /**
     * Returns the specific css class names
     *
     * @return
     */
    public String getCssClass () {
		return null;
	}
}
