/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2017 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.wcm.foundation.model.responsivegrid;

import aQute.bnd.annotation.ProviderType;
import com.adobe.cq.export.json.ComponentExporter;
import com.adobe.cq.export.json.ExporterConstants;
import com.day.cq.wcm.api.NameConstants;
import com.day.cq.wcm.api.TemplatedResource;
import com.day.cq.wcm.api.designer.ComponentStyle;
import com.day.cq.wcm.api.designer.Style;
import com.day.cq.wcm.foundation.model.responsivegrid.export.ResponsiveGridExporter;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.resource.AbstractResource;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceMetadata;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ValueMap;
import org.apache.sling.models.annotations.DefaultInjectionStrategy;
import org.apache.sling.models.annotations.Exporter;
import org.apache.sling.models.annotations.Model;
import org.apache.sling.models.annotations.injectorspecific.ScriptVariable;
import org.apache.sling.models.annotations.injectorspecific.Self;
import org.apache.sling.models.annotations.injectorspecific.SlingObject;
import org.apache.sling.models.factory.ModelFactory;

import javax.annotation.Nonnull;
import javax.annotation.PostConstruct;
import javax.inject.Inject;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;


/**
 * Sling model for the Responsive grid component.
 * A Responsive grid component provides access to its columns and generates a set of specific responsive data.
 */
@Model(
        adaptables                  = SlingHttpServletRequest.class,
        adapters                    = { ResponsiveGrid.class, ComponentExporter.class },
        defaultInjectionStrategy    = DefaultInjectionStrategy.OPTIONAL,
        resourceType                = ResponsiveGrid.RESOURCE_TYPE)
@Exporter(
        name                        = ExporterConstants.SLING_MODEL_EXPORTER_NAME,
        selector                    = ExporterConstants.SLING_MODEL_SELECTOR,
        extensions                  = ExporterConstants.SLING_MODEL_EXTENSION)
@JsonSerialize(as = ResponsiveGridExporter.class)
@ProviderType
public class ResponsiveGrid extends AbstractResource implements ResponsiveGridExporter {

    protected static final String RESOURCE_TYPE = "wcm/foundation/components/responsivegrid";

    @Self
    private SlingHttpServletRequest slingRequest;

    @SlingObject
    private volatile Resource resource;

    @ScriptVariable
    private ValueMap properties;

    @ScriptVariable
    private Style currentStyle;

    @Inject
    private ModelFactory modelFactory;

    /**
     * Class names of the responsive grid
     */
    private String classNames;

    /**
     * Child columns of the responsive grid
     */
    private Map<String, ResponsiveColumn> childColumns = new LinkedHashMap<String, ResponsiveColumn>();

    /**
     * Number of columns set on the design or the default number of columns
     */
    private int columns;

    @PostConstruct
    protected void initModel() {
	}

    @Override
    public String getGridClassNames() {
		return null;
	}

    @Override
    public int getColumnCount() {
		return 0;
	}

    /**
     * @return The columns of the current responsive grid.
     */
    @Nonnull
    public Collection<? extends ResponsiveColumn> getColumns() {
		return null;
	}

    /**
     * @return The columns of the current responsive grid.
     * @deprecated Use {@link #getColumns()}
     */
    public List<ResponsiveColumn> getParagraphs() {
		return null;
	}

    /**
     * @return The CSS class names to be applied to the current grid.
     * @deprecated Use {@link #getGridClassNames()}
     */
    public String getCssClass() {
		return null;
	}

    /**
     * @param <T> The type of the resource
     * @return Returns the resource optionally wrapped into a {@link TemplatedResource}
     *
     * AdobePatentID="P6273-US"
     */
    @Nonnull
    public <T extends Resource> T getEffectiveResource() {
		return null;
	}

    @Nonnull
    @Override
    public String getPath() {
		return null;
	}

    /**
     * @deprecated
     */
    @Nonnull
    @Override
    public String getResourceType() {
		return null;
	}

    /**
     * @deprecated
     */
    public String getResourceSuperType() {
		return null;
	}

    /**
     * @deprecated
     */
    @Nonnull
    @Override
    public ResourceMetadata getResourceMetadata() {
		return null;
	}

    /**
     * @deprecated
     */
    @Nonnull
    @Override
    public ResourceResolver getResourceResolver() {
		return null;
	}

    @Nonnull
    @Override
    public Map<String, ? extends ComponentExporter> getExportedItems() {
		return null;
	}

    @Nonnull
    @Override
    public String[] getExportedItemsOrder() {
		return null;
	}

    @Nonnull
    @Override
    public String getExportedType() {
		return null;
	}

}