/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.wcm.tags;

import javax.servlet.RequestDispatcher;
import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.BodyContent;
import javax.servlet.jsp.tagext.TagSupport;
import java.io.IOException;

import org.apache.commons.lang.StringUtils;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.request.RequestDispatcherOptions;
import org.apache.sling.api.request.RequestProgressTracker;
import org.apache.sling.api.request.RequestUtil;
import org.apache.sling.api.resource.NonExistingResource;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ResourceUtil;
import org.apache.sling.api.resource.SyntheticResource;
import org.apache.sling.api.resource.ValueMap;
import org.apache.sling.api.scripting.SlingBindings;
import org.apache.sling.api.scripting.SlingScriptHelper;
import org.apache.sling.api.servlets.ServletResolver;
import org.apache.sling.scripting.jsp.util.JspSlingHttpServletResponseWrapper;
import org.apache.sling.scripting.jsp.util.TagUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * <code>IncludeTag</code> implements the &lt;cq:include/&gt; tag.
 */
public class IncludeTag extends TagSupport {

    static final long serialVersionUID = -5953960896840203934L;

    /**
     * default logger
     */
    private static final Logger log = LoggerFactory.getLogger(IncludeTag.class);

    /**
     * resource type
     */
    private String resourceType;

    /**
     * path
     */
    private String path;

    /**
     * jsp script
     */
    private String script;

    /**
     * flush
     */
    private boolean flush;

    /**
     * defaultResourceType
     *

     */
    private String defaultResourceType;

    /**
     * ignores the component hierarchy and only respect scripts paths
     */
    private boolean ignoreComponentHierarchy;

    /**
     * {@inheritDoc}
     *
     * @return EVAL_PAGE
     * @throws JspException if an error occurs
     */
    public int doEndTag() throws JspException {
		return 0;
	}

    /**
     * Includes the given script.
     * @return EVAL_PAGE
     * @throws JspException if an error occurs
     */
    private int includeScript() throws JspException {
		return 0;
	}

    /**
     * Includes the rendering of a resource or path set by the respective
     * tag attribute.
     * This method is essentially the same as the doEndTag implementation of
     * (a previous version of) the Sling taglib include tag.
     *
     * @return
     * @throws JspException
     */
    private int includeResource() throws JspException {
		return 0;
	}

    /**
     * {@inheritDoc}
     */
    public void setPageContext(PageContext pageContext) {
	}

    /**
     * Sets the defaultResourceType attribute
     * @param type attribute value
     */
    public void setDefaultResourceType(String type) {
	}

    /**
     * Sets the resource type attribute
     * @param resourceType attribute value
     */
    public void setResourceType(String resourceType) {
	}

    /**
     * Sets the path attribute
     * @param path attribute value
     */
    public void setPath(String path) {
	}

    /**
     * Sets the script attribute
     * @param script attribute value
     */
    public void setScript(String script) {
	}

    /**
     * Sets the flush attribute
     * @param flush attribute value
     */
    public void setFlush(boolean flush) {
	}

    /**
     * Set the ignore component hierarchy attribute
     * @param ignoreComponentHierarchy attribute value
     */
    public void setIgnoreComponentHierarchy(boolean ignoreComponentHierarchy) {
	}
}