/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */

package com.day.cq.workflow.job;

import com.day.cq.workflow.exec.WorkItem;

import java.io.Serializable;
import java.util.Dictionary;
import java.util.Hashtable;
import java.util.Date;
import java.util.Calendar;

import org.osgi.service.event.Event;
import org.apache.sling.event.EventUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * The <code>TimeoutJob</code> class provides a utility for creating event
 * triggered job used for programmed/scripted workflow steps.
 */
public class TimeoutJob implements Serializable {

    private static final Logger log = LoggerFactory.getLogger(TimeoutJob.class);

	/** Generated serial version UID. */
	private static final long serialVersionUID = 5670996916430565635L;

	/** The job topic for adding an entry to the audit log. */
	public static final String TIMEOUT_JOB_TOPIC = "com/day/cq/workflow/timeout/job";

	/** The event property holding the {@link TimeoutJob}. */
	public static final String TIMEOUT_JOB = "com.day.cq.workflow.timeout.job";

	/** The {@link com.day.cq.workflow.exec.WorkItem} <code>Id</code> of the job. */
	protected String itemId;

    /** The timeout job handler */
    String handler;

    protected long timeStarted = 0;

    /** Creates a new WorkflowJob. */
	public TimeoutJob(WorkItem item, String handler) {
		if (item == null || handler == null) {
			throw new IllegalArgumentException("item or handler must not be null.");
		}
		this.itemId = item.getId();
        this.timeStarted = item.getTimeStarted().getTime();
        this.handler = handler;
    }

	/** Returns the {@link com.day.cq.workflow.exec.WorkItem} <code>Id</code> of the job */
	public String getWorkItemId() {
		return null;
	}

    /** Returns the timeout handler */
    public String getHandler(){
		return null;
	}

    /** Convenience method to create a job event for the workflow job. */
	public Event createEvent(boolean executeParallel, long seconds, boolean addOffset) {
		return null;
	}

    public Event cancelEvent(boolean executeParallel) {
		return null;
	}

    private Date calculateDate(long seconds, boolean addOffset) {
		return null;
	}
}
