/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */

package com.day.text;

/**
 * MD4 digest algorithm. Not contained in the standard message digest
 * implementations. Used by the {@link Text#digest} methods.
 */
public class MD4 {

    /**
     * Padding.
     */
    private static final byte[] PADDING = new byte[] {
        (byte) 0x80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
    };

    /**
     * Constants for transform routine.
     */
    private static final int S11 = 3;
    private static final int S12 = 7;
    private static final int S13 = 11;
    private static final int S14 = 19;
    private static final int S21 = 3;
    private static final int S22 = 5;
    private static final int S23 = 9;
    private static final int S24 = 13;
    private static final int S31 = 3;
    private static final int S32 = 9;
    private static final int S33 = 11;
    private static final int S34 = 15;

    /**
     * State (ABCD).
     */
    private int state[] = new int[4];

    /**
     * Number of bits, module 2^64 (lsb first).
     */
    private int count[] = new int[2];

    /**
     * Input buffer.
     */
    private byte buffer[] = new byte[64];

    /**
     * Create a new instance of this class.
     */
    public MD4() {
        init();
    }

    /**
     * Initialization. Begins an MD4 operation, writing a new context.
     */
    private void init() {
	}

    /**
     * Feed some more input.
     *
     * @param input input block
     * @param off offset inside input block
     * @param len number of valid bytes
     */
    public void update(byte[] input, int off, int len) {
	}


    /**
     * MD4 finalization. Ends an MD4 message-digest operation, writing the
     * message digest.
     *
     * @return message digest
     */
    public byte[] finish() {
		return null;
	}

    /**
     * MD4 basic transformation. Transforms state based on <code>block</code>,
     * which is assumed to have at least length 64.
     *
     * @param block block
     * @param offset offset inside block
     */
    private void transform(byte[] block, int offset) {
	}

    /**
     * Encodes <code>input</code> (int) into <code>output</code> (byte). Assumes
     * <code>len</code> is a multiple of 4.
     *
     * @param input input
     * @param len length
     * @param output output
     */
     private static void encode(int[] input, byte[] output, int off, int len) {
	}

    /**
     * Decodes <code>input</code> (byte) into <code>output</code> (int). Assumes
     * <code>len</code> is a multiple of 4.
     *
     * @param input input
     * @param off offset
     * @param len length
     * @param output output
     */
    private static void decode(byte[] input, int off, int len, int[] output) {
	}

    /**
     * FF, GG and HH are transformations for rounds 1, 2 and 3. Rotation
     * is separate from addition to prevent recomputation.
     */
    private static int FF(int a, int b, int c, int d, int x, int s) {
		return 0;
	}

    private static int GG(int a, int b, int c, int d, int x, int s) {
		return 0;
	}

    private static int HH(int a, int b, int c, int d, int x, int s) {
		return 0;
	}

    /**
     * Utility method that makes a single update and then finishes.
     *
     * @param input input
     * @return digest digest
     */
    public static byte[] digest(byte[] input) {
		return null;
	}
}