/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.jackrabbit.commons.observation;

import java.util.Map;
import java.util.concurrent.atomic.AtomicBoolean;

import javax.jcr.RepositoryException;
import javax.jcr.observation.Event;

/**
 * Event decorator that tracks whether user and date information is being
 * accessed from external events or without checking for externality.
 *
 * @see ListenerTracker
 */
class EventTracker implements Event {

    /** The enclosing listener tracker */
    private final ListenerTracker listener;

    protected final Event event;

    protected final AtomicBoolean externalAccessed =
            new AtomicBoolean();

    public EventTracker(ListenerTracker listenerTracker, Event event) {
        listener = listenerTracker;
        this.event = event;
    }

    private void userInfoAccessed() {
	}

    private void dateInfoAccessed() {
	}

    protected boolean eventIsExternal() {
		return false;
	}

    @Override
    public String toString() {
		return null;
	}

    @Override
    public int hashCode() {
		return 0;
	}

    @Override
    public boolean equals(Object other) {
		return false;
	}

    //---------------------------------------------------------< Event >--

    @Override
    public int getType() {
		return 0;
	}

    @Override
    public String getPath() throws RepositoryException {
		return null;
	}

    @Override
    public String getUserID() {
		return null;
	}

    @Override
    public String getIdentifier() throws RepositoryException {
		return null;
	}

    @Override
    public Map<?, ?> getInfo() throws RepositoryException {
		return null;
	}

    @Override
    public String getUserData() throws RepositoryException {
		return null;
	}

    @Override
    public long getDate() throws RepositoryException {
		return 0L;
	}

}