/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * File system {@link Backend} used with {@link CachingDataStore}. 
 * The file system can be network storage.
 */
package org.apache.jackrabbit.core.data;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.RandomAccessFile;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;
import java.util.Set;

import org.apache.commons.io.FileUtils;
import org.apache.commons.io.IOUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class FSBackend extends AbstractBackend {

    private Properties properties;

    private String fsPath;

    File fsPathDir;

    public static final String FS_BACKEND_PATH = "fsBackendPath";

    /**
     * Logger instance.
     */
    private static final Logger LOG = LoggerFactory.getLogger(FSBackend.class);

    /**
     * The maximum last modified time resolution of the file system.
     */
    private static final int ACCESS_TIME_RESOLUTION = 2000;

    @Override
    public void init(CachingDataStore store, String homeDir, String config)
                    throws DataStoreException {
					}

    public void init(CachingDataStore store, String homeDir, Properties prop)
                    throws DataStoreException {
					}

    @Override
    public InputStream read(DataIdentifier identifier)
                    throws DataStoreException {
						return null;
					}

    @Override
    public long getLength(DataIdentifier identifier) throws DataStoreException {
		return 0L;
	}

    @Override
    public long getLastModified(DataIdentifier identifier)
                    throws DataStoreException {
						return 0L;
					}

    @Override
    public void write(DataIdentifier identifier, File src)
                    throws DataStoreException {
					}

    @Override
    public void writeAsync(final DataIdentifier identifier, final File src,
                    final AsyncUploadCallback callback)
                    throws DataStoreException {
					}

    @Override
    public Iterator<DataIdentifier> getAllIdentifiers()
                    throws DataStoreException {
						return null;
					}

    @Override
    public boolean exists(DataIdentifier identifier, boolean touch)
                    throws DataStoreException {
						return false;
					}

    @Override
    public boolean exists(DataIdentifier identifier) throws DataStoreException {
		return false;
	}

    @Override
    public void touch(DataIdentifier identifier, long minModifiedDate)
                    throws DataStoreException {
					}

    @Override
    public void touchAsync(final DataIdentifier identifier,
                    final long minModifiedDate,
                    final AsyncTouchCallback callback)
                    throws DataStoreException {
					}

    @Override
    public Set<DataIdentifier> deleteAllOlderThan(long min)
                    throws DataStoreException {
						return null;
					}

    @Override
    public void deleteRecord(DataIdentifier identifier)
                    throws DataStoreException {
					}

    /**
     * Properties used to configure the backend. If provided explicitly before
     * init is invoked then these take precedence
     * @param properties to configure S3Backend
     */
    public void setProperties(Properties properties) {
	}

    /**
     * Returns the identified file. This method implements the pattern used to
     * avoid problems with too many files in a single directory.
     * <p>
     * No sanity checks are performed on the given identifier.
     * @param identifier data identifier
     * @return identified file
     */
    private File getFile(DataIdentifier identifier) {
		return null;
	}

    /**
     * Set the last modified date of a file, if the file is writable.
     * @param file the file
     * @param time the new last modified date
     * @throws DataStoreException if the file is writable but modifying the date
     *             fails
     */
    private static void setLastModified(File file, long time)
                    throws DataStoreException {
					}

    /**
     * Get the last modified date of a file.
     * @param file the file
     * @return the last modified date
     * @throws DataStoreException if reading fails
     */
    private static long getLastModified(File file) throws DataStoreException {
		return 0L;
	}

    private void listRecursive(List<File> list, File file) {
	}

    private void deleteEmptyParentDirs(File file) {
	}

    private void deleteOlderRecursive(File file, long min,
                    Set<DataIdentifier> deleteIdSet) throws DataStoreException {
					}
}
