/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.core.fs.local;

import org.apache.jackrabbit.core.fs.FileSystem;
import org.apache.jackrabbit.core.fs.FileSystemException;
import org.apache.jackrabbit.core.fs.local.FileUtil;
import org.apache.jackrabbit.core.fs.local.HandleMonitor;
import org.apache.jackrabbit.util.LazyFileInputStream;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.File;
import java.io.FileFilter;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * A <code>LocalFileSystem</code> ...
 */
public class LocalFileSystem implements FileSystem {

    private static Logger log = LoggerFactory.getLogger(LocalFileSystem.class);

    private File root;

    private HandleMonitor monitor;

    /**
     * Default constructor
     */
    public LocalFileSystem() {
    }

    public String getPath() {
		return null;
	}

    /**
     * Sets the path to the root directory of this local filesystem. please note
     * that this method can be called via reflection during initialization and
     * must not be altered.
     *
     * @param rootPath the path to the root directory
     */
    public void setPath(String rootPath) {
	}

    public void setRoot(File root) {
	}

    /**
     * Enables/Disables the use of the handle monitor.
     *
     * @param enable
     */
    public void setEnableHandleMonitor(String enable) {
	}

    /**
     * Enables/Disables the use of the handle monitor.
     *
     * @param enable flag
     */
    public void setEnableHandleMonitor(boolean enable) {
	}

    /**
     * Returns <code>true</code> if use of the handle monitor is currently
     * enabled, otherwise returns <code>false</code>.
     *
     * @see #setEnableHandleMonitor(boolean)
     */
    public String getEnableHandleMonitor() {
		return null;
	}

    private String osPath(String genericPath) {
		return null;
	}

    //-------------------------------------------< java.lang.Object overrides >
    public boolean equals(Object obj) {
		return false;
	}

    /**
     * Returns zero to satisfy the Object equals/hashCode contract.
     * This class is mutable and not meant to be used as a hash key.
     *
     * @return always zero
     * @see Object#hashCode()
     */
    public int hashCode() {
		return 0;
	}

    //-----------------------------------------------------------< FileSystem >
    /**
     * {@inheritDoc}
     */
    public void init() throws FileSystemException {
	}

    /**
     * {@inheritDoc}
     */
    public void close() throws FileSystemException {
	}

    /**
     * {@inheritDoc}
     */
    public void createFolder(String folderPath) throws FileSystemException {
	}

    /**
     * {@inheritDoc}
     */
    public void deleteFile(String filePath) throws FileSystemException {
	}

    /**
     * {@inheritDoc}
     */
    public void deleteFolder(String folderPath) throws FileSystemException {
	}

    /**
     * {@inheritDoc}
     */
    public boolean exists(String path) throws FileSystemException {
		return false;
	}

    /**
     * {@inheritDoc}
     */
    public InputStream getInputStream(String filePath)
            throws FileSystemException {
				return null;
			}

    /**
     * {@inheritDoc}
     */
    public OutputStream getOutputStream(String filePath)
            throws FileSystemException {
				return null;
			}

    /**
     * {@inheritDoc}
     */
    public boolean hasChildren(String path) throws FileSystemException {
		return false;
	}

    /**
     * {@inheritDoc}
     */
    public boolean isFile(String path) throws FileSystemException {
		return false;
	}

    /**
     * {@inheritDoc}
     */
    public boolean isFolder(String path) throws FileSystemException {
		return false;
	}

    /**
     * {@inheritDoc}
     */
    public long lastModified(String path) throws FileSystemException {
		return 0L;
	}

    /**
     * {@inheritDoc}
     */
    public long length(String filePath) throws FileSystemException {
		return 0L;
	}

    /**
     * {@inheritDoc}
     */
    public String[] list(String folderPath) throws FileSystemException {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public String[] listFiles(String folderPath) throws FileSystemException {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public String[] listFolders(String folderPath) throws FileSystemException {
		return null;
	}

}
