/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.apache.jackrabbit.oak.plugins.index.lucene.util;

import java.util.Collections;

import com.google.common.primitives.Ints;
import org.apache.jackrabbit.JcrConstants;
import org.apache.jackrabbit.oak.api.Blob;
import org.apache.jackrabbit.oak.api.PropertyState;
import org.apache.jackrabbit.oak.api.Type;
import org.apache.jackrabbit.oak.spi.state.NodeState;

import static com.google.common.base.Preconditions.checkArgument;

public class ConfigUtil {

    public static boolean getOptionalValue(NodeState definition, String propName, boolean defaultVal){
		return false;
	}

    public static int getOptionalValue(NodeState definition, String propName, int defaultVal){
		return 0;
	}

    public static String getOptionalValue(NodeState definition, String propName, String defaultVal){
		return null;
	}

    public static float getOptionalValue(NodeState definition, String propName, float defaultVal){
		return 0.0f;
	}

    public static double getOptionalValue(NodeState definition, String propName, double defaultVal){
		return 0.0d;
	}

    public static String getPrimaryTypeName(NodeState nodeState) {
		return null;
	}

    public static Iterable<String> getMixinNames(NodeState nodeState) {
		return null;
	}

    /**
     * Assumes that given state is of type nt:file and then reads
     * the jcr:content/@jcr:data property to get the binary content
     */
    public static Blob getBlob(NodeState state, String resourceName){
		return null;
	}
}
