/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.rmi.repository;

import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.net.MalformedURLException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.Map;

import javax.jcr.Repository;
import javax.jcr.RepositoryException;
import javax.jcr.RepositoryFactory;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.apache.jackrabbit.rmi.client.ClientAdapterFactory;
import org.apache.jackrabbit.rmi.client.LocalAdapterFactory;
import org.apache.jackrabbit.rmi.client.SafeClientRepository;
import org.apache.jackrabbit.rmi.remote.RemoteRepository;

public class RmiRepositoryFactory implements RepositoryFactory {

    private static final String REPOSITORY_URI =
        "org.apache.jackrabbit.repository.uri";

    @SuppressWarnings({"unchecked", "rawtypes"})
    public Repository getRepository(Map parameters) throws RepositoryException {
		return null;
	}

    private Repository getUrlRepository(final URL url)
            throws RepositoryException {
				return null;
			}

    @SuppressWarnings("rawtypes")
    private Repository getJndiRepository(final String name,
            final Hashtable environment) throws RepositoryException {
				return null;
			}

    private Repository getRmiRepository(final String name)
            throws RepositoryException {
				return null;
			}

    /**
     * Basic SafeClientRepository for the different lookup types of a rmi repository
     */
    private static class RmiSafeClientRepository extends SafeClientRepository {

        public RmiSafeClientRepository(LocalAdapterFactory factory) {
            super(factory);
        }

        @Override
        protected RemoteRepository getRemoteRepository() throws RemoteException {
			return null;
		}

    }
}
