/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.spi.commons.logging;

import javax.jcr.RepositoryException;

import org.apache.jackrabbit.spi.Name;
import org.apache.jackrabbit.spi.Path;
import org.apache.jackrabbit.spi.PathFactory;
import org.apache.jackrabbit.spi.Path.Element;

/**
 * Log wrapper for a {@link PathFactory}.
 */
public class PathFactoryLogger extends AbstractLogger implements PathFactory {
    private final PathFactory pathFactory;

    /**
     * Create a new instance for the given <code>pathFactory</code> which uses
     * <code>writer</code> for persisting log messages.
     * @param pathFactory
     * @param writer
     */
    public PathFactoryLogger(PathFactory pathFactory, LogWriter writer) {
        super(writer);
        this.pathFactory = pathFactory;
    }

    /**
     * @return  the wrapped PathFactory
     */
    public PathFactory getPathFactory() {
		return null;
	}

    public Path create(final Path parent, final Path relPath, final boolean normalize)
            throws RepositoryException {
				return null;
			}

    public Path create(final Path parent, final Name name, final boolean normalize)
            throws RepositoryException {
				return null;
			}

    public Path create(final Path parent, final Name name, final int index, final boolean normalize)
            throws RepositoryException {
				return null;
			}

    public Path create(final Name name) {
		return null;
	}

    public Path create(final Name name, final int index) {
		return null;
	}

    public Path create(final Element element) {
		return null;
	}

    public Path create(final Element[] elements) {
		return null;
	}

    public Path create(final String pathString) {
		return null;
	}

    public Element createElement(final Name name) {
		return null;
	}

    public Element createElement(final Name name, final int index) {
		return null;
	}

    public Element createElement(final String identifier) throws IllegalArgumentException {
		return null;
	}

    public Element getCurrentElement() {
		return null;
	}

    public Element getParentElement() {
		return null;
	}

    public Element getRootElement() {
		return null;
	}

    public Path getRootPath() {
		return null;
	}

}
