/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.spi.commons.name;

import javax.jcr.PathNotFoundException;

import org.apache.jackrabbit.spi.Name;
import org.apache.jackrabbit.spi.Path;

final class RootPath extends AbstractPath {

    /** Singleton instance */
    public static final RootPath ROOT_PATH = new RootPath();

    /** Serial version UID */
    private static final long serialVersionUID = 8621451607549214925L;

    /** Name of the root element */
    public static final Name NAME =
        NameFactoryImpl.getInstance().create(Name.NS_DEFAULT_URI, "");

    /** Hidden constructor */
    private RootPath() {
    }

    public Name getName() {
		return null;
	}

    /**
     * Returns <code>true</code> as this is the root path.
     *
     * @return <code>true</code>
     */
    @Override
    public boolean denotesRoot() {
		return false;
	}

    /**
     * Returns <code>false</code> as this is the root path.
     *
     * @return <code>false</code>
     */
    public boolean isIdentifierBased() {
		return false;
	}

    /**
     * Returns <code>true</code> as this is the root path.
     *
     * @return <code>true</code>
     */
    public boolean isAbsolute() {
		return false;
	}

    /**
     * Returns <code>true</code> as this is the root path.
     *
     * @return <code>true</code>
     */
    public boolean isCanonical() {
		return false;
	}

    /**
     * Returns <code>true</code> as this is the root path.
     *
     * @return <code>true</code>
     */
    public boolean isNormalized() {
		return false;
	}

    /**
     * Returns this path as this is the root path.
     *
     * @return root path
     */
    public Path getNormalizedPath() {
		return null;
	}

    /**
     * Returns this path as this is the root path.
     *
     * @return root path
     */
    public Path getCanonicalPath() {
		return null;
	}

    public Path getAncestor(int degree)
            throws IllegalArgumentException, PathNotFoundException {
				return null;
			}

    /**
     * Returns zero as this is the root path.
     *
     * @return zero
     */
    public int getAncestorCount() {
		return 0;
	}

    /**
     * Returns one as this is the root path.
     *
     * @return one
     */
    public int getLength() {
		return 0;
	}

    /**
     * Returns zero as this is the root path.
     *
     * @return zero
     */
    public int getDepth() {
		return 0;
	}

    public Path subPath(int from, int to) throws IllegalArgumentException {
		return null;
	}

    public Element[] getElements() {
		return null;
	}

    public Element getNameElement() {
		return null;
	}

    public String getString() {
		return null;
	}

    //--------------------------------------------------------< Serializable >

    /** Returns the singleton instance of this class */
    public Object readResolve() {
		return null;
	}

}
