/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.sling.discovery.commons.providers;

import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.apache.sling.discovery.ClusterView;
import org.apache.sling.discovery.InstanceDescription;

/**
 * Default implementation of the ClusterView interface.
 * <p>
 * Besides implementing the interface methods it also
 * adds add/remove of InstanceDescriptions as well as 
 * implementing equals and hashCode.
 */
public class DefaultClusterView implements ClusterView {

    /** the id of this cluster view **/
    private final String id;

    /** the list of instances as part of this cluster **/
    private final List<InstanceDescription> instances = new LinkedList<InstanceDescription>();

    public DefaultClusterView(final String id) {
        if (id == null || id.length() == 0) {
            throw new IllegalArgumentException("id must not be null");
        }
        this.id = id;
    }

    @Override
    public boolean equals(final Object obj) {
		return false;
	}
    
    @Override
    public String toString() {
		return null;
	}

    @Override
    public int hashCode() {
		return 0;
	}

    public String getId() {
		return null;
	}

    /**
     * Add the given instance to this cluster and set the cluster on the instance (back pointer)
     * @param instance the instance to add to this cluster
     */
    public void addInstanceDescription(final DefaultInstanceDescription instance) {
	}

    public List<InstanceDescription> getInstances() {
		return null;
	}

    public InstanceDescription getLeader() {
		return null;
	}

    /**
     * Lookup the leader of this cluster
     * @return the leader of this cluster - should never return null
     */
    private InstanceDescription doGetLeader() {
		return null;
	}

    /**
     * Removes the given instance from this cluster.
     * <p>
     * Note that the instance will still have a pointer to this cluster however.
     * @param instance the instance to remove from this cluster
     */
    public boolean removeInstanceDescription(InstanceDescription instance) {
		return false;
	}
    
    /**
     * Returns the local InstanceDescription or null if no local instance is listed
     * @return the local InstanceDescription or null if no local instance is listed
     * @throws IllegalStateException if multiple local instances are listed
     */
    public InstanceDescription getLocalInstance() {
		return null;
	}

}
